(defun c:chamfer1()
  (setq dcl_id (load_dialog "chamfer1.dcl"))
	(if (< dcl_id 0) (exit))
	(init_variables)
  (while (> what 2)
    (if (not (new_dialog "chamfer1" dcl_id)) (exit))
		(init_tiles)
		(get_actions)
	)
  (unload_dialog dcl_id)
);defun

;********************************************************************
;                        INIT_VARIABLES
;********************************************************************
(defun init_variables()
(setq what 3)
(setq   chammode  (getvar "chammode")
        chamfera  (getvar "chamfera")
        dist1     (rtos chamfera)
        chamferb  (getvar "chamferb")
        dist2     (rtos chamferb)
        chamferc  (getvar "chamferc")
        leng      (rtos chamferc)
        chamferd  (getvar "chamferd")
        angl      (angtos chamferd)
        trimmode  (getvar "trimmode")
        l         "1"
        pl        "0"
        dist0     "0"
        tip       "l"
);setq
(cond
  ((= chammode 0) (setq d "1" a "0"))
  ((= chammode 1) (setq d "0" a "1"))
);cond
(cond
  ((= trimmode 0) (setq mode "nt" t "0" nt "1"))
  ((= trimmode 1) (setq mode "t"  t "1" nt "0"))
);cond
);defun

;********************************************************************
;                           INIT_TILES
;********************************************************************
(defun init_tiles()
(set_tile "d"       d)
(set_tile "a"       a)
(set_tile "dist1"   dist1)
(set_tile "dist2"   dist2)
(set_tile "leng"    leng)
(set_tile "angl"    angl)
(set_tile "t"       t)
(set_tile "nt"      nt)
(set_tile "l"       l)
(set_tile "pl"      pl)
(set_tile "dist0"   dist0)

(mode_tile "dist0"  (- 1 (atoi d)))
(mode_tile "dist1"  (- 1 (atoi d)))
(mode_tile "dist2"  (- 1 (atoi d)))
(mode_tile "leng"   (- 1 (atoi a)))
(mode_tile "angl"   (- 1 (atoi a)))

);defun

;********************************************************************
;                           GET_ACTIONS
;********************************************************************
(defun  get_actions()
(action_tile "spos"   "(setq spos $value)   (spos_do)")
(action_tile "dist1"  "(setq dist1 $value)  (dist1_do)")
(action_tile "dist2"  "(setq dist2 $value)  (dist2_do)")
(action_tile "dist0"  "(dist0_do)")
(action_tile "leng"   "(setq leng $value)   (leng_do)")
(action_tile "angl"   "(setq angl $value)   (angl_do)")
(action_tile "mode"   "(setq mode $value)   (mode_do)")
(action_tile "tip"    "(setq tip  $value)   (tip_do)")
(action_tile "go"     "(done_dialog 3)")

(setq what (start_dialog))
(if (= what 3) (start_do))
);defun

;********************************************************************
;                              SPOS_DO
;********************************************************************
(defun spos_do()
(cond
  ( (= spos "d")
    (setq d "1" a "0")
    (setvar "chammode" 0)
  )
  ( (= spos "a")
    (setq d "0" a "1")
    (setvar "chammode" 1)
  )
);cond
(set_tile "d" d)
(set_tile "a" a)
(mode_tile "dist0"  (- 1 (atoi d)))
(mode_tile "dist1"  (- 1 (atoi d)))
(mode_tile "dist2"  (- 1 (atoi d)))
(mode_tile "leng"   (- 1 (atoi a)))
(mode_tile "angl"   (- 1 (atoi a)))
);defun

;********************************************************************
;                             DIST1_DO
;********************************************************************
(defun dist1_do()
(setvar "chamfera"  (distof dist1))
(setq dist1 (rtos (getvar "chamfera")))
(set_tile "dist1" dist1)
);defun

;********************************************************************
;                             DIST2_DO
;********************************************************************
(defun dist2_do()
(setvar "chamferb"  (distof dist2))
(setq dist2 (rtos (getvar "chamferb")))
(set_tile "dist2" dist2)
);defun

;********************************************************************
;                             DIST0_DO
;********************************************************************
(defun dist0_do()
(setq dist1 "0" dist2 "0")
(dist1_do)
(dist2_do)
(set_tile "dist0" dist0)
);defun

;********************************************************************
;                             LENG_DO
;********************************************************************
(defun leng_do()
(setvar "chamferc"  (distof leng))
(setq leng (rtos (getvar "chamferc")))
(set_tile "leng" leng)   
);defun

;********************************************************************
;                             ANGL_DO
;********************************************************************
(defun angl_do()
(setvar "chamferd"  (angtof angl))
(setq angl (angtos (getvar "chamferd")))
(set_tile "angl" angl)   
);defun

;********************************************************************
;                             MODE_DO
;********************************************************************
(defun mode_do()
(cond
((= mode "t") (setq trimmode 1 t "1" nt "0"))
((= mode "nt")(setq trimmode 0 t "0" nt "1"))
);cond
(setvar "trimmode" trimmode)
);defun

;********************************************************************
;                             TIP_DO
;********************************************************************
(defun tip_do()
(cond
((= tip "l") (setq l "1" pl "0"))
((= tip "pl")(setq l "0" pl "1"))
);cond
);defun

;********************************************************************
;                             START_DO
;********************************************************************
(defun start_do()
(cond
((= tip "l")  (command "chamfer" pause pause))
((= tip "pl") (command "chamfer" "p" pause pause))
);cond
);defun
