;;;*                      DDPIPE.LSP (Written By Kenny Ramage)
;;;*This is a merged file of all my Piping Routines.
;;;*Version 1.3 Written March 1997.
;;;*This set of routines, draws Metric Piping Sections.
;;;*Sections available are :-
;;;*      		Pipes
;;;*              Flanges
;;;*              Flanges in Elevation
;;;*              90 Degree Elbows
;;;*              45 Degree Elbows
;;;*              Concentric Reducers
;;;*              Eccentric Reducers
;;;*              Lobster Back Bends
;;;*All Section Properties are based on the South African Standards.
;;;*To draw sections, using custom dimensions, see DDPIPEC.LSP.
;;;*This programme was written by Kenny Ramage over a number of years, and is
;;;*constantly being updated & improved.
;;;*You are welcome to give to friends/colleagues, but please give me credit.
;;;*I can be contacted at the following :-
;;;*                 E-Mail ndbe51d1@db.za
;;;*                 Phone 092646332-2837
;;;*                       092646332-3737
;;;*                   Fax 092646332-3848
;;;*                  Post P.O. Box 1127
;;;*                       Oranjemund
;;;*                       NAMIBIA
;;;*                       9000
;;;*     Enjoy...........Bugs and all........
;;;*=========================================================================
;;;*Revisions and Updates
;;;*Pipe Break and Pipe End added. March 1997
;;;*Grab routine added, programme updated & error routine revised-March '97
;;;*Routine updated for R14 and dialogue boxes streamlined-March '98
;;;*=========================================================================
;;;*NOTE!!!
;;;*Ddpipe.Dcl & Ddpipe.Dat must be in the Acad support path.
;;;*DWG Files M8, M10, M12, M16, M20, M24 & M30 must also be in the
;;;*Acad search path.
;;;*=========================================================================
(prompt "\nPiping Version 2.1 1998 \nby Kenny Ramage ndbe51d1@db.za")
(defun C:DDPIPE ( / siz dcl_id userclick)
  (initerr)
  (setq userclick1 T)
  (setvar "BLIPMODE" 0)
  (setvar "CMDECHO" 0)
  (setvar "OSMODE" 0)
     (setq SIZ "PIPE")
     (setq dcl_id (load_dialog "ddpipe.dcl"))
     (if (not (new_dialog "ddpipe" dcl_id) ) (exit))
     (setq w (dimx_tile "im")
	   h (dimy_tile "im"))
     (start_image "im")
     (fill_image 0 0 w h 5)
     (setq w1 (/ w 2))
     (setq h1 (/ h 2))
     (vector_image 0 h w1 0 2)
     (vector_image w1 0 w h 2)
     (vector_image 0 h w1 h1 2)
     (vector_image w1 h1 w h 2)
     (end_image)
     (action_tile "PI"
         "(setq SIZ \"PIPE\")")
     (action_tile "FL"
         "(setq SIZ \"FLANGE\")")
     (action_tile "FLE"
         "(setq SIZ \"FLANGEL\")")
     (action_tile "ELB"
         "(setq SIZ \"ELB90\")")         
     (action_tile "ELBO"
         "(setq SIZ \"ELB45\")")
     (action_tile "CR"
         "(setq SIZ \"REDCON\")")
     (action_tile "ER"
         "(setq SIZ \"REDECC\")")         
     (action_tile "LOB90"
         "(setq SIZ \"LOB90\")")
     (action_tile "LOB45"
         "(setq SIZ \"LOB45\")")
     (action_tile "LOB22"
         "(setq SIZ \"LOB22\")")
     (action_tile "EP"
         "(setq SIZ \"PIPEND\")")
     (action_tile "PB"
         "(setq SIZ \"CUTUBE\")")
     (action_tile "cancel"
         "(done_dialog)(setq userclick nil)")
     (action_tile "accept"
        "(done_dialog)(setq userclick T)"
     )
     (start_dialog)
     (unload_dialog dcl_id)
       (if userclick
	 (progn
           (if (eq SIZ "PIPE") (PIPE))
           (if (eq SIZ "FLANGE") (FLANGE))
           (if (eq SIZ "FLANGEL") (FLANGEL))
           (if (eq SIZ "ELB90") (ELB90))
           (if (eq SIZ "ELB45") (ELB45))
           (if (eq SIZ "REDCON") (REDCON))
           (if (eq SIZ "REDECC") (REDECC))
           (if (eq SIZ "LOB90") (LOB90))
           (if (eq SIZ "LOB45") (LOB45))
           (if (eq SIZ "LOB22") (LOB22))
           (if (eq SIZ "PIPEND") (PIPEND))
           (if (eq SIZ "CUTUBE") (CUTUBE))
        );progn
      );if
    (reset)
  (if (= userclick1 nil)
    (c:ddpipe)
  );  
  (princ)
);defun
;*
;;;*THIS PARAMETRIC ROUTINE DRAWS PIPES
;;;*Written by K. Ramage February 1995
;;;*Merged with DDPIPE.LSP March 1997
;;;*--------------------------------------------------------
(defun PIPE ( / siz siza file fp itema dataa maxs count chrct numb dlist
                  P1 P2 P3 P4 P5 P6 P7 P8 P9 OD ID DIST IP ANG NAMES
	          dcl_id)
;;;*---------------------------------------------------------
;;;*INITIALISE
        (setvar "CMDECHO" 0)
        (setvar "BLIPMODE" 0)
(setq NAMES '("15NB" "20NB" "25NB" "40NB" "50NB" "65NB" "80NB" "90NB" "100NB" "125NB"
                            "150NB" "200NB" "250NB" "300NB" "350NB" "400NB" "450NB" "500NB" "550NB"
                            "600NB" "650NB" "700NB" "750NB" "800NB" "850NB" "900NB" "1000NB"))
     (setq dcl_id (load_dialog "ddpipe.dcl"))
     (if (not (new_dialog "pipe" dcl_id) ) (exit))
     (start_list "selections")
     (mapcar ' add_list NAMES)
     (end_list)
     (action_tile "cancel"
        "(done_dialog) (setq userclick1 nil)")
     (action_tile "accept"
        (strcat
          "(progn (setq SIZ (atof (get_tile \"selections\")))"
          " (done_dialog)(setq userclick1 T))"
        )
      )
     (start_dialog)
     (unload_dialog dcl_id)
     (if userclick1
       (progn
     (setq SIZ (fix SIZ))
     (setq SIZ (nth SIZ NAMES))
;;*----------------------------------------------------------
;;;*FILE & INFORMATION RETRIEVAL ROUTINE.
  (setq dlist nil
         siza (strcat "*" siz)
        file (findfile "DDPIPE.DAT")
        fp (open file "r")
        itema (read-line fp)                  
  );setq;;;*-----------------------------------------------------------
(grab)
;;;*THIS ROUTINE DRAWS A PIPE.
       (mapcar 'set '(OD ID) dlist)
       (setvar "OSMODE" OLDSNAP)
      (while
       (setq IP (getpoint "\nStart Point of Pipe: "))
       (setq P1 (getpoint IP "\nEnd Point of Pipe : "))
       (setvar "OSMODE" 0)
       (setq ANG (angle IP P1))
       (setq ANG (RTD ANG))
       (setq DIST (distance IP P1))
       (setq P2 (polar IP (DTR (+ ANG 90.0)) (/ OD 2))
             P3 (polar P2 (DTR ANG) DIST)
             P4 (polar IP (DTR (+ ANG 270.0)) (/ OD 2))
             P5 (polar P4 (DTR ANG) DIST)
             P6 (polar IP (DTR (+ ANG 90.0)) (/ ID 2))
             P7 (polar P6 (DTR ANG) DIST)
             P8 (polar IP (DTR (+ ANG 270.0)) (/ ID 2))
             P9 (polar P8 (DTR ANG) DIST)
       );setq
       (command "LAYER" "M" "2" ""
                "LINE" P6 P7 ""
                "LINE" P8 P9 ""
                "LAYER" "M" "7" ""
                "LINE" P2 P3 ""
                "LINE" P4 P5 ""
       );command
       (setvar "OSMODE" OLDSNAP)
       );while
      );progn
     );if
   (princ)
);defun PIPE
;;;*==========================================================================
;;;THIS PARAMETRIC ROUTINE DRAWS STANDARD PIPE FLANGES. (SABS 1000/3)  
;;;Written by K. Ramage September 1994.
;;;*Merged with DDPIPE.LSP March 1997
(defun flange ( / siz siza file itema dataa dline dlist maxs count chrct numb
                     nb od id pcd ip p1 ra bolt bolt1 names)
  (setvar "BLIPMODE" 0)
  (setvar "CMDECHO" 0)
  (setq NAMES '("15NB" "20NB" "25NB" "40NB" "50NB" "65NB" "80NB" "90NB" "100NB" "125NB"
                            "150NB" "200NB" "250NB" "300NB" "350NB" "400NB" "450NB" "500NB" "550NB"
                            "600NB" "650NB" "700NB" "750NB" "800NB" "850NB" "900NB" "1000NB"))
     (setq dcl_id (load_dialog "ddpipe.dcl"))
     (if (not (new_dialog "flange" dcl_id) ) (exit))
     (start_list "selections")
     (mapcar ' add_list NAMES)
     (end_list)
     (action_tile "cancel"
        "(done_dialog) (setq userclick1 nil)")
     (action_tile "accept"
        (strcat
          "(progn (setq SIZ (atof (get_tile \"selections\")))"
          " (done_dialog)(setq userclick1 T))"
        )
      )
     (start_dialog)
     (unload_dialog dcl_id)
  (if userclick1
    (progn
     (setq SIZ (fix SIZ))
     (setq SIZ (nth SIZ NAMES))
  (setq siza (strcat "*" siz)
        siza (strcat siza "F")
        file (findfile "DDPIPE.DAT")
        fp (open file "r")
        itema (read-line fp)                  ;first line is a label for file
  );setq
  (grab)
      (mapcar 'set '(od id pcd nb bolt) dlist)
      (setq nb (fix nb)
            od (/ od 2)
            id (/ id 2)
            pcd (/ pcd 2)
      );setq
     (setvar "OSMODE" OLDSNAP)
     (while
     (setq ip (getpoint "\nInsertion Point: ")
            ra (/ 180 nb)
            ra (float ra)
            p1 (polar ip (* pi (/ ra 180)) pcd)
            bolt1 (strcat "M" (rtos bolt))
            bolt1 (strcat bolt1 "S")
      );setq
       (setvar "osmode" 0)
      (command "insert" "ddpipe")
      (command)
      (command "LAYER" "M" "3" ""
               "CIRCLE" ip pcd
               "LAYER" "M" "7" ""
               "CIRCLE" ip od
               "CIRCLE" ip id
               "INSERT" bolt1 p1 "" "" ra
               "ARRAY" "L" "" "P" ip nb "360" "Y"
      );command
      (setvar "OSMODE" OLDSNAP)
      );while
        );progn
    );if
      (princ)
);defun
;*
;;;*THIS PARAMETRIC ROUTINE DRAWS A FLANGE IN ELEVATION
;;;*Written by K. Ramage February 1995
;;;*Merged with DDPIPE.LSP March 1997
;;;*--------------------------------------------------------
(defun FLANGEL ( / siz siza file fp itema dataa maxs count chrct numb dlist
                     P1 P2 P3 P4 P5 P6 P7 P8 P9 P10 P11 ANG IP D B IP1 NAMES)
;;;*---------------------------------------------------------
;;;*INITIALISE
        (setvar "CMDECHO" 0)
        (setvar "BLIPMODE" 0)
     (setq NAMES '("15NB" "20NB" "25NB" "40NB" "50NB" "65NB" "80NB" "90NB" "100NB" "125NB"
                            "150NB" "200NB" "250NB" "300NB" "350NB" "400NB" "450NB" "500NB" "550NB"
                            "600NB" "650NB" "700NB" "750NB" "800NB" "850NB" "900NB" "1000NB"))
     (setq dcl_id (load_dialog "ddpipe.dcl"))
     (if (not (new_dialog "flangel" dcl_id) ) (exit))
     (start_list "selections")
     (mapcar ' add_list NAMES)
     (end_list)
     (action_tile "cancel"
        "(done_dialog) (setq userclick1 nil)")
     (action_tile "accept"
        (strcat
          "(progn (setq SIZ (atof (get_tile \"selections\")))"
          " (done_dialog)(setq userclick1 T))"
        )
      )
     (start_dialog)
     (unload_dialog dcl_id)
  (if userclick1
    (progn
     (setq SIZ (fix SIZ))
     (setq SIZ (nth SIZ NAMES))
;;;*----------------------------------------------------------
;;;*FILE & INFORMATION RETRIEVAL ROUTINE.
  (setq dlist nil
         siza (strcat "*" siz)
         siza (strcat siza "E")
        file (findfile "DDPIPE.DAT")
        fp (open file "r")
        itema (read-line fp)                  
  );setq
  (grab)
;;;*-----------------------------------------------------------
;;;*THIS ROUTINE DRAWS A FLANGE IN ELEVATION.
       (mapcar 'set '(D B) dlist)
      (setvar "OSMODE" OLDSNAP)
     (while
       (setq IP (getpoint "\nInsertion Point: "))
       (setvar "OSMODE" 544)
       (setq IP1 (getpoint IP "\nDirection to Bottom of Flange: "))
       (setq ANG (angle IP IP1))
       (setq ANG (RTD ANG))
       (setvar "OSMODE" 0)
       (setq P1 (polar IP (DTR (- ANG 90.0)) (/ D 2))
             P2 (polar P1 (DTR ANG) B)
             P3 (polar P2 (DTR (+ ANG 90.0)) D)
             P4 (polar P3 (DTR (+ ANG 180.0)) B)
             P5 (polar P4 (DTR ANG) 1)
             P6 (polar P5 (DTR (- ANG 90.0)) 1)
             P7 (polar P1 (DTR ANG) 1)
             P8 (polar P7 (DTR (+ ANG 90.0 )) 1)
             P9 (polar IP (DTR ANG) 1)
            P10 (polar P9 (DTR (- ANG 90.0)) 1)
            P11 (polar P9 (DTR (+ ANG 90.0)) 1)
       );setq
       (command "LAYER" "M" "7" ""
                "PLINE" IP "W" "0.0" "" P1 P2 P3 P4 "close"
                "TRIM" P2 "" "F" P11 P6 "" ""
                "TRIM" P2 "" "F" P8 P10 "" ""
       );command
       (setvar "OSMODE" OLDSNAP)
       );while
       );progn
    );if
   (princ)
);defun FLANGEL
;;;*THIS PARAMETRIC ROUTINE DRAWS 90 DEGREE PIPE BENDS
;;;*Written by K. Ramage February 1995
;;;*--------------------------------------------------------
(defun ELB90 ( / siz siza file fp itema dataa maxs count chrct numb dlist
                 N S W E P1 P2 P3 P4 P5 P6 P7 P8 P9 P10 OD ID CP A IP NAMES dcl_id)
;;;*---------------------------------------------------------
;;;*CONVERT TO RADIANS
   (setq N (* pi (/ 90.0 180.0))
         S (* pi (/ 270.0 180.0))
         W pi
         E 0
   );setq
;;;*----------------------------------------------------------
;;;*INITIALISE
        (setvar "CMDECHO" 0)
        (setvar "BLIPMODE" 0)
  (setq NAMES '("15NB-LR" "20NB-LR" "25NB-LR" "40NB-LR" "50NB-LR" "65NB-LR" "80NB-LR" "90NB-LR" "100NB-LR" "125NB-LR"
                            "150NB-LR" "200NB-LR" "250NB-LR" "300NB-LR" "350NB-LR" "400NB-LR" "450NB-LR" "500NB-LR" "550NB-LR"
                            "600NB-LR" "15NB-SR" "20NB-SR" "25NB-SR" "40NB-SR" "50NB-SR" "65NB-SR" "80NB-SR" "90NB-SR" "100NB-SR" "125NB-SR"
                            "150NB-SR" "200NB-SR" "250NB-SR" "300NB-SR" "350NB-SR" "400NB-SR" "450NB-SR" "500NB-SR" "550NB-SR" "600NB-SR"))
     (setq dcl_id (load_dialog "ddpipe.dcl"))
     (if (not (new_dialog "elb90" dcl_id) ) (exit))
     (start_list "selections")
     (mapcar ' add_list NAMES)
     (end_list)
     (action_tile "cancel"
        "(done_dialog) (setq userclick1 nil)")
     (action_tile "accept"
        (strcat
          "(progn (setq SIZ (atof (get_tile \"selections\")))"
          " (done_dialog)(setq userclick1 T))"
        )
      )
     (start_dialog)
     (unload_dialog dcl_id)
  (if userclick1
    (progn
     (setq SIZ (fix SIZ))
     (setq SIZ (nth SIZ NAMES))
;;;*----------------------------------------------------------
;;;*FILE & INFORMATION RETRIEVAL ROUTINE.
  (setq dlist nil
          siza (strcat "*" siz)
        file (findfile "DDPIPE.DAT")
        fp (open file "r")
        itema (read-line fp)                  
  );setq
  (grab)
;;;*-----------------------------------------------------------
;;;*THIS ROUTINE DRAWS A 90 DEGREE BEND.
       (mapcar 'set '(OD A ID) dlist)
      (setvar "OSMODE" OLDSNAP)
     (while
        (setq IP (getpoint "\nInsertion Point: "))
       (setvar "OSMODE" 0)      
       (setq P1 (polar IP E A)        
             P2 (polar IP S A)
             CP (polar P1 S A)
             P3 (polar P1 N (/ ID 2))
             P4 (polar P1 S (/ ID 2))
             P5 (polar P2 W (/ ID 2))
             P6 (polar P2 E (/ ID 2))
             P7 (polar P1 N (/ OD 2))
             P8 (polar P1 S (/ OD 2))
             P9 (polar P2 W (/ OD 2))
            P10 (polar P2 E (/ OD 2))
       );setq
       (mark)
       (command "LAYER" "M" "3" ""
                "ARC" "C" CP P1 P2
                "LAYER" "M" "7" ""
                "ARC" "C" CP P7 P9
                "ARC" "C" CP P8 P10
                "LAYER" "M" "2" ""
                "ARC" "C" CP P3 P5
                "ARC" "C" CP P4 P6
                "LAYER" "M" "7" ""
                "LINE" P7 P8 ""
                "LINE" P9 P10 ""
       );command
       (prompt "\nRotation Angle : ")
       (command "ROTATE" (catch) "" IP pause)
       (setvar "OSMODE" OLDSNAP)
       );while
      );progn
    );if
   (princ)
);defun ELB90
;;;*THIS PARAMETRIC ROUTINE DRAWS 45 DEGREE PIPE BENDS
;;;*Written by K. Ramage February 1995
;;;*--------------------------------------------------------
(defun ELB45 ( / siz siza file fp itema dataa maxs count chrct numb dlist
                 N S W E P1 P2 P3 P4 P5 P6 P7 P8 P9 P10 P11 B OD ID CP A IP NAMES)
;;;*---------------------------------------------------------
;;;*CONVERT TO RADIANS
   (setq N (* pi (/ 90.0 180.0))
         S (* pi (/ 270.0 180.0))
         W pi
         E 0
        NE (* pi (/ 45.0 180.0))
        NW (* pi (/ 135.0 180.0))
        SW (* pi (/ 225.0 180.0))
        SE (* pi (/ 315.0 180.0))
   );setq
;;;*----------------------------------------------------------
;;;*INITIALISE
        (setvar "BLIPMODE" 0)
(setq NAMES '("15NB-LR" "20NB-LR" "25NB-LR" "40NB-LR" "50NB-LR" "65NB-LR" "80NB-LR" "90NB-LR" "100NB-LR" "125NB-LR"
                            "150NB-LR" "200NB-LR" "250NB-LR" "300NB-LR" "350NB-LR" "400NB-LR" "450NB-LR" "500NB-LR" "550NB-LR"
                            "600NB-LR"))
     (setq dcl_id (load_dialog "ddpipe.dcl"))
     (if (not (new_dialog "elb45" dcl_id) ) (exit))
     (start_list "selections")
     (mapcar ' add_list NAMES)
     (end_list)
     (action_tile "cancel"
        "(done_dialog) (setq userclick1 nil)")
     (action_tile "accept"
        (strcat
          "(progn (setq SIZ (atof (get_tile \"selections\")))"
          " (done_dialog)(setq userclick1 T))"
        )
      )
     (start_dialog)
     (unload_dialog dcl_id)
  (if userclick1
    (progn
     (setq SIZ (fix SIZ))
     (setq SIZ (nth SIZ NAMES))
;;;*----------------------------------------------------------
;;;*FILE & INFORMATION RETRIEVAL ROUTINE.
  (setq dlist nil
        siza (strcat "*" siz)
        siza (strcat siza "B")
        file (findfile "DDPIPE.DAT")
        fp (open file "r")
        itema (read-line fp)                  
  );setq
  (grab)
;;;*-----------------------------------------------------------
;;;*THIS ROUTINE DRAWS A 45 DEGREE BEND.
       (mapcar 'set '(OD A ID B) dlist)
       (setvar "OSMODE" OLDSNAP)
     (while
       (setq IP (getpoint "\nInsertion Point: "))
       (setvar "OSMODE" 0)      
       (setq P1 (polar IP S B)        
             P2 (polar IP NE B)
             CP (polar P1 E A)
             P3 (polar P1 W (/ ID 2))
             P4 (polar P2 NW (/ ID 2))
             P5 (polar P2 SE (/ ID 2))
             P6 (polar P1 E (/ ID 2))
             P7 (polar P1 W (/ OD 2))
             P8 (polar P2 NW (/ OD 2))
             P9 (polar P2 SE (/ OD 2))
            P10 (polar P1 E (/ OD 2))
            P11 (polar P9 N (/ (SQRT (* OD OD)) 2))
       );setq
       (mark)
       (command "LAYER" "M" "3" ""
                "ARC" "C" CP P2 P1
                "LAYER" "M" "7" ""
                "ARC" "C" CP P8 P7
                "ARC" "C" CP P9 P10
                "LAYER" "M" "2" ""
                "ARC" "C" CP P4 P3
                "ARC" "C" CP P5 P6
                "LAYER" "M" "7" ""
                "LINE" P7 P10 ""
                "LINE" P8 P9 ""
       );command
       (prompt "\nRotation Angle : ")
       (command "ROTATE" (catch) "" IP pause)
       (setvar "OSMODE" OLDSNAP)
       );while
      );progn
    );if
   (princ)
);defun ELB45
;;;*THIS PARAMETRIC ROUTINE DRAWS CONCENTRIC REDUCERS
;;;*Written by K. Ramage February 1995
;;;*--------------------------------------------------------
(defun REDCON ( / siz siza file fp itema dataa maxs count chrct numb dlist
                  P1 P2 P3 P4 P5 P6 P7 P8 P9  OD1 ID1 IP OD2 ID2 L NAMES)
;;;*---------------------------------------------------------
;;;*INITIALISE
        (setvar "CMDECHO" 0)
        (setvar "BLIPMODE" 0)
 (setq NAMES '("20X15NB" "25X15NB" "25X20NB" "32X15NB" "32X20NB" "32X25NB" "40X15NB" "40X20NB" "40X25NB"
                            "40X32NB" "50X15NB" "50X20NB" "50X25NB" "50X32NB" "50X40NB" "65X25NB" "65X32NB" "65X40NB"
                            "65X50NB" "80X25NB" "80X32NB" "80X40NB" "80X50NB" "80X65NB" "100X25NB" "100X32NB" "100X40NB"
                            "100X50NB" "100X65NB" "100X80NB" "125X50NB" "125X65NB" "125X80NB" "125X100NB" "150X50NB"
                            "150X65NB" "150X80NB" "150X90NB" "150X100NB" "150X125NB" "200X80NB" "200X90NB" "200X100NB"
                            "200X125NB" "200X150NB" "250X80NB" "250X100NB" "200X125NB" "250X150NB" "250X200NB"
                            "300X100NB" "300X125NB" "300X150NB" "300X200NB" "300X250NB" "350X150NB" "350X200NB"
                            "350X200NB" "350X300NB" "400X200NB" "400X250NB" "400X300NB" "400X350NB" "450X300NB"
                            "450X300NB" "450X400NB" "500X350NB" "500X400NB" "500X450NB" "600X400NB" "600X450NB"
                            "600X400NB"))
     (setq dcl_id (load_dialog "ddpipe.dcl"))
     (if (not (new_dialog "redcon" dcl_id) ) (exit))
     (start_list "selections")
     (mapcar ' add_list NAMES)
     (end_list)
     (action_tile "cancel"
        "(done_dialog) (setq userclick1 nil)")
     (action_tile "accept"
        (strcat
          "(progn (setq SIZ (atof (get_tile \"selections\")))"
          " (done_dialog)(setq userclick1 T))"
        )
      )
     (start_dialog)
     (unload_dialog dcl_id)
  (if userclick1
    (progn
     (setq SIZ (fix SIZ))
     (setq SIZ (nth SIZ NAMES))
;;;*----------------------------------------------------------
;;;*FILE & INFORMATION RETRIEVAL ROUTINE.
  (setq dlist nil
        siza (strcat "*" siz)
        file (findfile "DDPIPE.DAT")
        fp (open file "r")
        itema (read-line fp)                  
  );setq
  (grab)
;;;*-----------------------------------------------------------
;;;*THIS ROUTINE DRAWS A CONCENTRIC REDUCER.
       (mapcar 'set '(OD1 ID1 OD2 ID2 L) dlist)
       (setvar "OSMODE" OLDSNAP)
     (while
       (setq IP (getpoint "\nInsertion Point <LARGE Diameter>: "))
       (setq P1 (getpoint IP "\nDirection of SMALL Diameter: ")
            ANG (angle IP P1)
            ANG (RTD ANG)
       );setq
       (setvar "OSMODE" 0)
       (setq P1 (polar IP (DTR ANG) L)        
             P2 (polar IP (DTR (+ ANG 90.0)) (/ ID1 2))
             P3 (polar P1 (DTR (+ ANG 90.0)) (/ ID2 2))
             P4 (polar IP (DTR (+ ANG 270.0)) (/ ID1 2))
             P5 (polar P1 (DTR (+ ANG 270.0)) (/ ID2 2))
             P6 (polar IP (DTR (+ ANG 90.0)) (/ OD1 2))
             P7 (polar P1 (DTR (+ ANG 90.0)) (/ OD2 2))
             P8 (polar IP (DTR (+ ANG 270.0)) (/ OD1 2))
             P9 (polar P1 (DTR (+ ANG 270.0)) (/ OD2 2))
       );setq
       (command "LAYER" "M" "2" ""
                "LINE" P2 P3 ""
                "LINE" P4 P5 ""
                "LAYER" "M" "7" ""
                "LINE" P6 P7 ""
                "LINE" P8 P9 ""
                "LINE" P6 P8 ""
                "LINE" P7 P9 ""
        );command
        (setvar "OSMODE" OLDSNAP)
       );while
       );progn
    );if
   (princ)
);defun REDCON
;;;*THIS PARAMETRIC ROUTINE DRAWS ECCENTRIC REDUCERS
;;;*Written by K. Ramage February 1995
;;;*--------------------------------------------------------
(defun REDECC ( / siz siza file fp itema dataa maxs count chrct numb dlist
                  P1 P1A P2 P3 P4 P5 P6 P7 P8 P9  OD1 ID1 IP OD2 ID2 L NAMES)
;;;*---------------------------------------------------------
;;;*INITIALISE
        (setvar "CMDECHO" 0)
        (setvar "BLIPMODE" 0)
 (setq NAMES '("20X15NB" "25X15NB" "25X20NB" "32X15NB" "32X20NB" "32X25NB" "40X15NB" "40X20NB" "40X25NB"
                            "40X32NB" "50X15NB" "50X20NB" "50X25NB" "50X32NB" "50X40NB" "65X25NB" "65X32NB" "65X40NB"
                            "65X50NB" "80X25NB" "80X32NB" "80X40NB" "80X50NB" "80X65NB" "100X25NB" "100X32NB" "100X40NB"
                            "100X50NB" "100X65NB" "100X80NB" "125X50NB" "125X65NB" "125X80NB" "125X100NB" "150X50NB"
                            "150X65NB" "150X80NB" "150X90NB" "150X100NB" "150X125NB" "200X80NB" "200X90NB" "200X100NB"
                            "200X125NB" "200X150NB" "250X80NB" "250X100NB" "200X125NB" "250X150NB" "250X200NB"
                            "300X100NB" "300X125NB" "300X150NB" "300X200NB" "300X250NB" "350X150NB" "350X200NB"
                            "350X200NB" "350X300NB" "400X200NB" "400X250NB" "400X300NB" "400X350NB" "450X300NB"
                            "450X300NB" "450X400NB" "500X350NB" "500X400NB" "500X450NB" "600X400NB" "600X450NB"
                            "600X400NB"))
     (setq dcl_id (load_dialog "ddpipe.dcl"))
     (if (not (new_dialog "redecc" dcl_id) ) (exit))
     (start_list "selections")
     (mapcar ' add_list NAMES)
     (end_list)
     (action_tile "cancel"
        "(done_dialog) (setq userclick1 nil)")
     (action_tile "accept"
        (strcat
          "(progn (setq SIZ (atof (get_tile \"selections\")))"
          " (done_dialog)(setq userclick1 T))"
        )
      )
     (start_dialog)
     (unload_dialog dcl_id)
  (if userclick1
    (progn
     (setq SIZ (fix SIZ))
     (setq SIZ (nth SIZ NAMES))
;;;*----------------------------------------------------------
;;;*FILE & INFORMATION RETRIEVAL ROUTINE.
  (setq dlist nil
         siza (strcat "*" siz)
        file (findfile "DDPIPE.DAT")
        fp (open file "r")
        itema (read-line fp)                  
  );setq
  (grab)
;;;*-----------------------------------------------------------
;;;*THIS ROUTINE DRAWS AN ECCENTRIC REDUCER.
       (mapcar 'set '(OD1 ID1 OD2 ID2 L) dlist)
       (setvar "OSMODE" OLDSNAP)
     (while
       (setq IP (getpoint "\nInsertion Point <LARGE Diameter>: "))
       (setq P1 (getpoint IP "\nDirection of SMALL Diameter: ")
            ANG (angle IP P1)
            ANG (RTD ANG)
       );setq
       (setvar "OSMODE" 0)
       (setq P1 (polar IP (DTR ANG) L)        
            P1A (polar P1 (DTR (+ ANG 270.0)) (- (/ OD1 2) (/ OD2 2)))
             P2 (polar IP (DTR (+ ANG 90.0)) (/ ID1 2))
             P3 (polar P1A (DTR (+ ANG 90.0)) (/ ID2 2))
             P4 (polar IP (DTR (+ ANG 270.0)) (/ ID1 2))
             P5 (polar P1A (DTR (+ ANG 270.0)) (/ ID2 2))
             P6 (polar IP (DTR (+ ANG 90.0)) (/ OD1 2))
             P7 (polar P1A (DTR (+ ANG 90.0)) (/ OD2 2))
             P8 (polar IP (DTR (+ ANG 270.0)) (/ OD1 2))
             P9 (polar P1A (DTR (+ ANG 270.0)) (/ OD2 2))
       );setq
       (command "LAYER" "M" "2" ""
                "LINE" P2 P3 ""
                "LINE" P4 P5 ""
                "LAYER" "M" "3" ""
                "LINE" IP P1A ""
                "LAYER" "M" "7" ""
                "LINE" P6 P7 ""
                "LINE" P8 P9 ""
                "LINE" P6 P8 ""
                "LINE" P7 P9 ""
        );command
        (setvar "OSMODE" OLDSNAP)
       );while
      );progn
    );if
   (princ)
);defun REDECC
;;;*THIS PARAMETRIC ROUTINE DRAWS 46-90 DEGREE LOBSTER BACKS
;;;*Written by K. Ramage February 1995
;;;*--------------------------------------------------------
(defun LOB90 ( / siz siza file fp itema dataa maxs count chrct numb dlist
                 P1 P2 P3 P4 P5 P6 P7 P8 P9 P10 P11 OD ID NU CP IP
                 R P12 P13 P14 P15 P16 P17 P18 ANG ANG1 NAMES)
;;;*---------------------------------------------------------
;;;*INITIALISE
        (setvar "CMDECHO" 0)
        (setvar "BLIPMODE" 0)
 (setq FLAG1 nil) 
 (setq NU4 4.0)
 (setq ANG2 90.0) 
 (setq NAMES '("200NB-LR" "250NB-LR" "300NB-LR" "350NB-LR" "400NB-LR" "450NB-LR" "500NB-LR" "550NB-LR"
                            "600NB-LR" "650NB-LR" "700NB-LR" "750NB-LR" "800NB-LR" "850NB-LR" "900NB-LR"
                             "200NB-MR" "250NB-MR" "300NB-MR" "350NB-MR" "400NB-MR" "450NB-MR" "500NB-MR" "550NB-MR"
                            "600NB-MR" "650NB-MR" "700NB-MR" "750NB-MR" "800NB-MR" "850NB-MR" "900NB-MR"
                             "200NB-SR" "250NB-SR" "300NB-SR" "350NB-SR" "400NB-SR" "450NB-SR" "500NB-SR" "550NB-SR"
                            "600NB-SR" "650NB-SR" "700NB-SR" "750NB-SR" "800NB-SR" "850NB-SR" "900NB-SR"))
     (setq dcl_id (load_dialog "ddpipe.dcl"))
     (if (not (new_dialog "lob90" dcl_id) ) (exit))
     (start_list "selections")
     (mapcar ' add_list NAMES)
     (end_list)
    (set_tile "eb1" "90")
    (set_tile "eb2" "4")
     (action_tile "cancel"
        "(done_dialog) (setq userclick1 nil)")
     (action_tile "accept"
        (strcat
          "(progn (setq SIZ (atof (get_tile \"selections\")))"
	          "(setq ANG2 (atof (get_tile \"eb1\")))"
                  "(setq NU4 (atof (get_tile \"eb2\")))"
          " (done_dialog)(setq userclick1 T))"
        )
      )
     (start_dialog)
     (unload_dialog dcl_id)
  (if userclick1
    (progn
     (setq SIZ (fix SIZ))
     (setq SIZ (nth SIZ NAMES))
;;;*----------------------------------------------------------
;;;*FILE & INFORMATION RETRIEVAL ROUTINE.
  (setq dlist nil
        siza (strcat "*" siz)
        siza (strcat siza "L")
        file (findfile "DDPIPE.DAT")
        fp (open file "r")
        itema (read-line fp)                  
  );setq
  (grab)
;;;*-----------------------------------------------------------
;;;*THIS ROUTINE DRAWS 46-90 DEGREE LOBSTER BACK BENDS.
       (mapcar 'set '(OD ID R) dlist)
   (if (and (> ANG2 45.0) (< ANG2 90.1))
    (progn
     (setvar "OSMODE" OLDSNAP)
     (while
       (setq IP (getpoint "\nInsertion Point: "))
       (setq NU NU4)
       (setq ANG2 (float ANG2))
       (setvar "OSMODE" 0)      
       (setq NU (- NU 1.0)
            ANG (/ ANG2 NU)
           ANG1 (/ ANG 2.0)
             R1 (/ R (COS (DTR (/ ANG2 2)))) 
              L (SQRT (- (* R1 R1) (* R R)))
             P1 (polar IP (DTR (+ 90.0 ANG2)) L)
             P2 (polar IP (DTR 270.0) L)
             CP (polar P2 (DTR 180.0) R)
             D1 (- R (/ OD 2.0))
             D2 (- R (/ ID 2.0))
             D3 (+ R (/ ID 2.0))
             D4 (+ R (/ OD 2.0))
             D5 (/ D1 (cos (DTR ANG1)))
             D6 (/ D2 (cos (DTR ANG1)))
             D7 (/ D3 (cos (DTR ANG1)))
             D8 (/ D4 (cos (DTR ANG1)))
             P3 (polar CP (DTR 0.0) D1)
             P4 (polar CP (DTR 0.0) D2)
             P5 (polar CP (DTR 0.0) D3)
             P6 (polar CP (DTR 0.0) D4)
             P7 (polar CP (DTR ANG2) D1)
             P8 (polar CP (DTR ANG2) D2)
             P9 (polar CP (DTR ANG2) D3)
            P10 (polar CP (DTR ANG2) D4)
            P11 (polar CP (DTR ANG1) D5)
            P12 (polar CP (DTR ANG1) D6)
            P13 (polar CP (DTR ANG1) D7)
            P14 (polar CP (DTR ANG1) D8)
        );setq
       (mark)
       (command "LAYER" "M" "3" ""
                "ARC" "C" CP P2 P1
                "LAYER" "M" "7" ""
                "PLINE" P3 "W" "0.0" "" P6 P14 P11 P3 ""
                "LAYER" "M" "2" ""
                "PLINE" P5 P13 ""
                "PLINE" P4 P12 ""
       );command
     (setq NU (- NU 1.0))
     (setq NU (fix NU))
   (if (> NU 0)
    (progn
     (repeat NU
       (setq ANG1 (+ ANG1 ANG)
              P15 (polar CP (DTR ANG1) D5)
              P16 (polar CP (DTR ANG1) D6)
              P17 (polar CP (DTR ANG1) D7)
              P18 (polar CP (DTR ANG1) D8)
       );setq
       (command "LAYER" "M" "2" ""
                "PLINE" P13 P17 ""
                "PLINE" P12 P16 ""
                "LAYER" "M" "7" ""
                "PLINE" P14 P18 P15 P11 ""
       );command
       (setq P14 P18
             P13 P17
             P12 P16
             P11 P15
       );setq
    );repeat
   );progn
  );if
       (setq P18 P14
             P17 P13
             P16 P12
             P15 P11
       );setq      
       (command "LAYER" "M" "7" ""
                "PLINE" P18 P10  P7 P15 ""
                "LAYER" "M" "2" ""
                "PLINE" P17 P9 ""
                "PLINE" P16 P8 ""
                "LAYER" "M" "7" ""
       );command
       (prompt "\nRotation Angle : ")
       (command "ROTATE" (catch) "" IP pause)
       (setvar "OSMODE" OLDSNAP)
    );while
    );progn
     (setq flag1 T)
    );if 
   );progn
  );if
   (if flag1
    (progn
      (alert "\nAngle must be between\n45 degrees and 90 degrees")
     (LOB90)
    );progn  
   );if  
   (princ)
);defun LOB90
;;;*THIS PARAMETRIC ROUTINE DRAWS 22.6-45 DEGREE LOBSTER BACKS
;;;*Written by K. Ramage February 1995
;;;*--------------------------------------------------------
(defun LOB45 ( / siz siza file fp itema dataa maxs count chrct numb dlist
                 P1 P2 P3 P4 P5 P6 P7 P8 P9 P10 P11 OD ID NU CP IP
                 R P12 P13 P14 P15 P16 P17 P18 ANG ANG1 B NAMES)
;;;*---------------------------------------------------------
;;;*INITIALISE
        (setvar "CMDECHO" 0)
        (setvar "BLIPMODE" 0)
        (setq FLAG1 nil)
        (setq NU4 4.0)
        (setq ANG2 45.0)
 (setq NAMES '("200NB-LR" "250NB-LR" "300NB-LR" "350NB-LR" "400NB-LR" "450NB-LR" "500NB-LR" "550NB-LR"
                            "600NB-LR" "650NB-LR" "700NB-LR" "750NB-LR" "800NB-LR" "850NB-LR" "900NB-LR"
                             "200NB-MR" "250NB-MR" "300NB-MR" "350NB-MR" "400NB-MR" "450NB-MR" "500NB-MR" "550NB-MR"
                            "600NB-MR" "650NB-MR" "700NB-MR" "750NB-MR" "800NB-MR" "850NB-MR" "900NB-MR"
                             "200NB-SR" "250NB-SR" "300NB-SR" "350NB-SR" "400NB-SR" "450NB-SR" "500NB-SR" "550NB-SR"
                            "600NB-SR" "650NB-SR" "700NB-SR" "750NB-SR" "800NB-SR" "850NB-SR" "900NB-SR"))
     (setq dcl_id (load_dialog "ddpipe.dcl"))
     (if (not (new_dialog "lob45" dcl_id) ) (exit))
     (start_list "selections")
     (mapcar ' add_list NAMES)
     (end_list)
     (set_tile "eb1" "45")
     (set_tile "eb2" "4")
     (action_tile "cancel"
        "(done_dialog) (setq userclick1 nil)")
     (action_tile "accept"
        (strcat
          "(progn (setq SIZ (atof (get_tile \"selections\")))"
	  "(setq ANG2 (atof (get_tile \"eb1\")))"
          "(setq NU4 (atof (get_tile \"eb2\")))"				    
          " (done_dialog)(setq userclick1 T))"
        )
      )
     (start_dialog)
     (unload_dialog dcl_id)
  (if userclick1
    (progn
     (setq SIZ (fix SIZ))
     (setq SIZ (nth SIZ NAMES))
;;;*----------------------------------------------------------
;;;*FILE & INFORMATION RETRIEVAL ROUTINE.
  (setq dlist nil
        siza (strcat "*" siz)
        siza (strcat siza "M")
        file (findfile "DDPIPE.DAT")
        fp (open file "r")
        itema (read-line fp)                  
  );setq
  (grab)
;;;*-----------------------------------------------------------
;;;*THIS ROUTINE DRAWS 22.6-45 DEGREE LOBSTER BACK BENDS.
       (mapcar 'set '(OD ID R B) dlist)
       (if (and (> ANG2 22.5) (< ANG2 45.1))
        (progn
	(setvar "OSMODE" OLDSNAP)
     (while
       (setq IP (getpoint "\nInsertion Point: "))
       (setq NU NU4)
       (setq ANG2 (float ANG2))
       (setvar "OSMODE" 0)      
       (setq NU (- NU 1.0)
            ANG (/ ANG2 NU)
           ANG1 (/ ANG 2.0)
             R1 (/ R (COS (DTR (/ ANG2 2)))) 
              L (SQRT (- (* R1 R1) (* R R)))
             P1 (polar IP (DTR (+ 90.0 ANG2)) L)
             P2 (polar IP (DTR 270.0) L)
             CP (polar P2 (DTR 180.0) R)
             D1 (- R (/ OD 2.0))
             D2 (- R (/ ID 2.0))
             D3 (+ R (/ ID 2.0))
             D4 (+ R (/ OD 2.0))
             D5 (/ D1 (cos (DTR ANG1)))
             D6 (/ D2 (cos (DTR ANG1)))
             D7 (/ D3 (cos (DTR ANG1)))
             D8 (/ D4 (cos (DTR ANG1)))
             P3 (polar CP (DTR 0.0) D1)
             P4 (polar CP (DTR 0.0) D2)
             P5 (polar CP (DTR 0.0) D3)
             P6 (polar CP (DTR 0.0) D4)
             P7 (polar CP (DTR ANG2) D1)
             P8 (polar CP (DTR ANG2) D2)
             P9 (polar CP (DTR ANG2) D3)
            P10 (polar CP (DTR ANG2) D4)
            P11 (polar CP (DTR ANG1) D5)
            P12 (polar CP (DTR ANG1) D6)
            P13 (polar CP (DTR ANG1) D7)
            P14 (polar CP (DTR ANG1) D8)
        );setq
       (mark)
       (command "LAYER" "M" "3" ""
                "ARC" "C" CP P2 P1
                "LAYER" "M" "7" ""
                "PLINE" P3 "W" "0.0" "" P6 P14 P11 P3 ""
                "LAYER" "M" "2" ""
                "PLINE" P5 P13 ""
                "PLINE" P4 P12 ""
       );command
     (setq NU (- NU 1.0))
     (setq NU (fix NU))
   (if (> NU 0)
    (progn
     (repeat NU
       (setq ANG1 (+ ANG1 ANG)
              P15 (polar CP (DTR ANG1) D5)
              P16 (polar CP (DTR ANG1) D6)
              P17 (polar CP (DTR ANG1) D7)
              P18 (polar CP (DTR ANG1) D8)
       );setq
       (command "LAYER" "M" "2" ""
                "PLINE" P13 P17 ""
                "PLINE" P12 P16 ""
                "LAYER" "M" "7" ""
                "PLINE" P14 P18 P15 P11 ""
       );command
       (setq P14 P18
             P13 P17
             P12 P16
             P11 P15
       );setq
    );repeat
   );progn
  );if
       (setq P18 P14
             P17 P13
             P16 P12
             P15 P11
       );setq      
       (command "LAYER" "M" "7" ""
                "PLINE" P18 P10  P7 P15 ""
                "LAYER" "M" "2" ""
                "PLINE" P17 P9 ""
                "PLINE" P16 P8 ""
                "LAYER" "M" "7" ""
       );command
       (setq B (- B L)
           P2A (polar P2 (DTR 270.0) B)
           P11 (polar P3 (DTR 270.0) B)
           P12 (polar P4 (DTR 270.0) B)
           P13 (polar P5 (DTR 270.0) B)
           P14 (polar P6 (DTR 270.0) B)
           P1A (polar P1 (DTR (+ 90.0 ANG2)) B)
           P15 (polar P7 (DTR (+ 90.0 ANG2)) B)
           P16 (polar P8 (DTR (+ 90.0 ANG2)) B)
           P17 (polar P9 (DTR (+ 90.0 ANG2)) B)
           P18 (polar P10 (DTR (+ 90.0 ANG2)) B)
       );setq        
       (command "LAYER" "M" "3" ""
                "LINE" P1 P1A ""
                "LINE" P2 P2A ""
                "LAYER" "M" "2" ""
                "LINE" P8 P16 ""
                "LINE" P9 P17 ""
                "LINE" P4 P12 ""
                "LINE" P5 P13 ""
                "LAYER" "M" "7" ""
                "LINE" P7 P15 ""
                "LINE" P10 P18 ""
                "LINE" P3 P11 ""
                "LINE" P6 P14 ""
                "LINE" P15 P18 ""
                "LINE" P11 P14 ""
        );command
       (prompt "\nRotation Angle : ")
       (command "ROTATE" (catch) "" IP pause)
       (setvar "OSMODE" OLDSNAP)
   );while
    );progn
     (setq flag1 T)
    );if 
   );progn
  );if
   (if flag1
    (progn
      (alert "\nAngle must be between\n22.5 degrees and 45 degrees")
     (LOB45)
    );progn  
   );if  
   (princ)
);defun LOB45
;;;*THIS PARAMETRIC ROUTINE DRAWS 1-22.5 DEGREE LOBSTER BACKS
;;;*Written by K. Ramage February 1995
;;;*--------------------------------------------------------
(defun LOB22 ( / siz siza file fp itema dataa maxs count chrct numb dlist
                 P1 P2 P3 P4 P5 P6 P7 P8 P9 P10 P11 OD ID NU CP IP
                 R P12 P13 P14 P15 P16 P17 P18 ANG ANG1 B NAMES)
;;;*---------------------------------------------------------
;;;*INITIALISE
        (setvar "CMDECHO" 0)
        (setvar "BLIPMODE" 0)
        (setq FLAG1 nil)
        (setq NU4 3.0)
        (setq ANG2 22.5)
(setq NAMES '("200NB-LR" "250NB-LR" "300NB-LR" "350NB-LR" "400NB-LR" "450NB-LR" "500NB-LR" "550NB-LR"
                            "600NB-LR" "650NB-LR" "700NB-LR" "750NB-LR" "800NB-LR" "850NB-LR" "900NB-LR"
                             "200NB-MR" "250NB-MR" "300NB-MR" "350NB-MR" "400NB-MR" "450NB-MR" "500NB-MR" "550NB-MR"
                            "600NB-MR" "650NB-MR" "700NB-MR" "750NB-MR" "800NB-MR" "850NB-MR" "900NB-MR"
                             "200NB-SR" "250NB-SR" "300NB-SR" "350NB-SR" "400NB-SR" "450NB-SR" "500NB-SR" "550NB-SR"
                            "600NB-SR" "650NB-SR" "700NB-SR" "750NB-SR" "800NB-SR" "850NB-SR" "900NB-SR"))
     (setq dcl_id (load_dialog "ddpipe.dcl"))
     (if (not (new_dialog "lob22" dcl_id) ) (exit))
     (start_list "selections")
     (mapcar ' add_list NAMES)
     (end_list)
     (set_tile "eb1" "22.5")
     (set_tile "eb2" "3")
     (action_tile "cancel"
        "(done_dialog) (setq userclick1 nil)")
     (action_tile "accept"
        (strcat
          "(progn (setq SIZ (atof (get_tile \"selections\")))"
	  "(setq ANG2 (atof (get_tile \"eb1\")))"
	  "(setq NU4 (atof (get_tile \"eb2\")))"
          " (done_dialog)(setq userclick1 T))"
        )
      )
     (start_dialog)
     (unload_dialog dcl_id)
  (if userclick1
    (progn
     (setq SIZ (fix SIZ))
     (setq SIZ (nth SIZ NAMES))
;;;*----------------------------------------------------------
;;;*FILE & INFORMATION RETRIEVAL ROUTINE.
  (setq dlist nil
        siza (strcat "*" siz)
        siza (strcat siza "N")
        file (findfile "DDPIPE.DAT")
        fp (open file "r")
        itema (read-line fp)                  
  );setq
  (grab)
;;;*-----------------------------------------------------------
;;;*THIS ROUTINE DRAWS 1-22.5 DEGREE LOBSTER BACK BENDS.
       (mapcar 'set '(OD ID R B) dlist)
       (if (and (> ANG2 1.0) (< ANG2 22.6))
        (progn
	(setvar "OSMODE" OLDSNAP)
     (while
       (setq IP (getpoint "\nInsertion Point: "))
       (setq NU NU4)
       (setq ANG2 (float ANG2))
       (setvar "OSMODE" 0)
       (setq NU (- NU 1.0)
            ANG (/ ANG2 NU)
           ANG1 (/ ANG 2.0)
             R1 (/ R (COS (DTR (/ ANG2 2)))) 
              L (SQRT (- (* R1 R1) (* R R)))
             P1 (polar IP (DTR (+ 90.0 ANG2)) L)
             P2 (polar IP (DTR 270.0) L)
             CP (polar P2 (DTR 180.0) R)
             D1 (- R (/ OD 2.0))
             D2 (- R (/ ID 2.0))
             D3 (+ R (/ ID 2.0))
             D4 (+ R (/ OD 2.0))
             D5 (/ D1 (cos (DTR ANG1)))
             D6 (/ D2 (cos (DTR ANG1)))
             D7 (/ D3 (cos (DTR ANG1)))
             D8 (/ D4 (cos (DTR ANG1)))
             P3 (polar CP (DTR 0.0) D1)
             P4 (polar CP (DTR 0.0) D2)
             P5 (polar CP (DTR 0.0) D3)
             P6 (polar CP (DTR 0.0) D4)
             P7 (polar CP (DTR ANG2) D1)
             P8 (polar CP (DTR ANG2) D2)
             P9 (polar CP (DTR ANG2) D3)
            P10 (polar CP (DTR ANG2) D4)
            P11 (polar CP (DTR ANG1) D5)
            P12 (polar CP (DTR ANG1) D6)
            P13 (polar CP (DTR ANG1) D7)
            P14 (polar CP (DTR ANG1) D8)
        );setq
       (mark)
       (command "LAYER" "M" "3" ""
                "ARC" "C" CP P2 P1
                "LAYER" "M" "7" ""
                "PLINE" P3 "W" "0.0" "" P6 P14 P11 P3 ""
                "LAYER" "M" "2" ""
                "PLINE" P5 P13 ""
                "PLINE" P4 P12 ""
       );command
     (setq NU (- NU 1.0))
     (setq NU (fix NU))
   (if (> NU 0)
    (progn
     (repeat NU
       (setq ANG1 (+ ANG1 ANG)
              P15 (polar CP (DTR ANG1) D5)
              P16 (polar CP (DTR ANG1) D6)
              P17 (polar CP (DTR ANG1) D7)
              P18 (polar CP (DTR ANG1) D8)
       );setq
       (command "LAYER" "M" "2" ""
                "PLINE" P13 P17 ""
                "PLINE" P12 P16 ""
                "LAYER" "M" "7" ""
                "PLINE" P14 P18 P15 P11 ""
       );command
       (setq P14 P18
             P13 P17
             P12 P16
             P11 P15
       );setq
    );repeat
   );progn
  );if
       (setq P18 P14
             P17 P13
             P16 P12
             P15 P11
       );setq      
       (command "LAYER" "M" "7" ""
                "PLINE" P18 P10  P7 P15 ""
                "LAYER" "M" "2" ""
                "PLINE" P17 P9 ""
                "PLINE" P16 P8 ""
                "LAYER" "M" "7" ""
       );command
       (setq B (- B L)
           P2A (polar P2 (DTR 270.0) B)
           P11 (polar P3 (DTR 270.0) B)
           P12 (polar P4 (DTR 270.0) B)
           P13 (polar P5 (DTR 270.0) B)
           P14 (polar P6 (DTR 270.0) B)
           P1A (polar P1 (DTR (+ 90.0 ANG2)) B)
           P15 (polar P7 (DTR (+ 90.0 ANG2)) B)
           P16 (polar P8 (DTR (+ 90.0 ANG2)) B)
           P17 (polar P9 (DTR (+ 90.0 ANG2)) B)
           P18 (polar P10 (DTR (+ 90.0 ANG2)) B)
       );setq        
       (command "LAYER" "M" "3" ""
                "LINE" P1 P1A ""
                "LINE" P2 P2A ""
                "LAYER" "M" "2" ""
                "LINE" P8 P16 ""
                "LINE" P9 P17 ""
                "LINE" P4 P12 ""
                "LINE" P5 P13 ""
                "LAYER" "M" "7" ""
                "LINE" P7 P15 ""
                "LINE" P10 P18 ""
                "LINE" P3 P11 ""
                "LINE" P6 P14 ""
                "LINE" P15 P18 ""
                "LINE" P11 P14 ""
        );command
       (prompt "\nRotation Angle : ")
       (command "ROTATE" (catch) "" IP pause)
       (setvar "OSMODE" OLDSNAP)
   );while
    );progn
     (setq flag1 T)
    );if 
   );progn
  );if
   (if flag1
    (progn
      (alert "\nAngle must be between\n1 degree and 22.5 degrees")
     (LOB22)
    );progn  
   );if  
   (princ)
);defun LOB22

;;;*PIPEND.LSP command shows the symbol for a pipe running perpendicular
;;;*to the drawing plane
(defun PIPEND ( / P1 R E1 C_BLIP HP1 QP1 HR P2 P3 P4 P5 ANS)
  (setvar "osmode" 0)
  (setvar "cmdecho" 0)
  (SETQ C_BLIP (GETVAR "BLIPMODE"))
  (graphscr)
  (setq E1 (car (entsel "\nPick circle for pipe end: ")))
  (if E1
    (progn
      (setq E1 (entget E1))             ;entity dataa list
      (if (= (cdr (assoc '0 E1)) "CIRCLE")
        (progn
          (setq P1 (cdr (assoc 10 E1)))   ;start of circle
          (setq R (cdr (assoc 40 E1)))    ;circle radius
          (setq HPI (/ PI 2.0))                 ;half value of PI
          (setq QPI (/ PI 4.0))                 ;quarter value of PI
          (setq HR (/ r 2.0))                   ;half value of radius
          (setq P2 (polar P1 HPI R))            ;upper end
          (setq P3 (polar P1 HPI HR))           ;half way between points
          (setq P3 (polar P3 PI HR))            ;over half radius
          (setq P4 (polar P1 (+ PI HPI) R))     ;lower end
          (setq P5 (polar P1 (+ PI HPI) HR))    ;half way between points
          (setq P5 (polar p5 0.0 HR))           ;over half radius
          (setvar "blipmode" 0)
          (command "pline" P2 "arc" "s" P3 P1 "s" P5 P4 "")
          (setq ANS nil)
          (setq ANS
             (strcase
               (getstring "\nShade in half the symbol <y/N>? ")
             )
          )
          (if (= ANS "Y")
             (progn
                (command "pline" P2 "arc" "ce" P1 P4 "s" P5 P1 "s" P3 P2 "")
                (command "hatch" "u" 45 (/ R 12.0) "n" "l" "")
                (command "erase" "p" "")
                (redraw)
             )
          )
          (setvar "blipmode" 1)
          (setvar "cmdecho" 1)
        );end prog
        (prompt "\nEntity not a circle.")
      );end if
    );end progn
    (prompt "\nNothing selected.")
  );end if
  (SETVAR "BLIPMODE" 0)
  (princ)
);end of command
;CUTUBE.LSP
;a command to show break symbol in a pipe or tube
;cutubex - routine to draw the curved lines as one polyline
(defun cutubex ()
  (setq P1A (polar P1 A QD))
  (setq P1A (polar P1A (+ A HPI) (/ QD 2.0)))
  (setq P2A (polar P2 A QD))
  (setq P2A (polar P2A (- A HPI) (/ QD 2.0)))
  (setq P3A (polar P2A (+ A HPI) QD))
  (setvar "blipmode" 0)
  (command "pline" P1 "arc" "S" P1A P2 "S" P2A P3 "S" P3A P2 "")
)
(defun CUTUBE ()
  (setvar "osmode" 0)
  (setvar "cmdecho" 0)                  ;turn off screen echo
  (setq CL (getvar "clayer"))           ;get current layer
  (setq HPI (/ PI 2.0))                 ;make half of PI a variable
  (setq E1 (entsel "\nSelect one side of Pipe: "))
  (setq P1 (osnap (cadr E1) "near"))    ;no entity select nearest
  (setq LY1 (entget (car E1)))
  (setq LY1 (cdr (assoc 8 LY1)))        ;get entity layer name
  (setq E3 (entsel "\nSelect other side: "))
  (setq P3 (osnap (cadr E3) "near"))    ;no entity select nearest
  (setq LY2 (entget (car E3)))
  (setq LY2 (cdr (assoc 8 LY2)))        ;get entity layer name
  (setq A (angle P1 P3))                ;angle between two picked points
  (setq D (distance P1 P3))             ;distance between two picked points
  (setq HD (/ D 2.0))                   ;half the distance
  (setq QD (/ HD 2.0))                  ;quarter the distance
  (setq P2 (polar P1 A HD))             ;find midpoint between picked points
  (setq P1X P1)                         ;p1x used if wrong orientation
  (if (/= LY1 LY2)
     (prompt "\nLines are on different layers.")
     (progn
          (command "layer" "S" ly1 "")  ;set the temporary layer
          (cutubex)
          (setq ans (strcase (getstring "\nChange orientation <y/N>? ")))
          (if (= ans "Y")                       ;if yes do the following
             (progn
               (setvar "highlight" 0)           ;turn of graphics higlighting
               (setq P1 P3 P3 P1X)              ;switch points
               (setq A (angle P1 P3))           ;change angle between picked points
               (command "erase" "L" "")         ;get rid of wrong one
               (cutubex)                        ;create the curves again
               (setvar "highlight" 1)           ;reset highlighting
             )
          )
          (setq ANS nil)                        ;reset variable ANS to nil
          (setq ANS (strcase (getstring "\nBreak one side <y/N>?")))
          (if (= ANS "Y")
             (progn
                (prompt "\n<select point on line>")
                (setq DIR (getpoint p1 "\nselect side to break: "))
                (setq A1 (angle P1 DIR))        ;select side and find angle
                (setq D1 (distance P1 DIR))     ;use picked distance for break point
                (setq P1X (polar P1 A1 D1))     ;point along the first picked side
                (setq P3X (polar P3 A1 D1))     ;point along the second picked side
                (setvar "highlight" 0)          ;turn highlighting off
                (command "break" P3X P3)        ;break first side
                (command "break" p1x p1)        ;break second side
                (setvar "highlight" 1)          ;turn highlighting on
             )
          )
          (setq ANS nil)                        ;reset variable ANS to nil
          (setq ANS (strcase (getstring "\nDarken half symbol <y/N>? ")))
          (if (= ANS "Y")                       ;if yes, do the following
             (progn
                (prompt "   wait..")            ;takes a little while
                (setvar "blipmode" 0)           ;turn blips off
                (setvar "highlight" 0)          ;turn off highlighting
                                                ;create a closed curve to hatch
                (command "pline" P2 "arc" "S" P2A P3 "S" P3A P2 "")
                                                ;hatch closed curve with 12 lines
                (command "Hatch" "U" (rtd A) (/ QD 12.0) "N" "L" "")
                (command "erase" "P" "")        ;erase closed curve
                (redraw)                        ;redraw screen
                (setvar "blipmode" 1)           ;turn blips back on
                (setvar "highlight" 1)          ;turn highlighting back on
             )
          )
          (command "layer" "S" CL "")           ;reset the current layer
       );end of progn for matching layer names
   );end of if for matching layer names
(princ)                               ;quiet exit
);end of command



(defun grab ()
  (while itema                                 
    (if (= itema siza)
      (setq dataa (read-line fp)               
            itema nil                          
      );setq
      (setq itema (read-line fp))              
    );if
  );while
  (if dataa                                    
    (progn
      (setq maxs (strlen dataa)                
        count 1   chrct 1                     
      );setq
      (while (< count maxs)                   
        (if (/= "," (substr dataa count 1))    
          (setq chrct (1+ chrct))             
          (setq numb (atof (substr dataa (1+ (- count chrct)) chrct))  
                dlist (append dlist (list numb))    
                chrct 1                             
          );setq
        );if
        (setq count (1+ count))                     
      );while
      (setq numb (atof (substr dataa (1+ (- count chrct)))) 
            dlist (append dlist (list numb))        
      );setq
    );progn
  );if dataa
  (close fp)
);defun
(princ)
;;;*==========================================================
;;;*==========================================================
(defun initerr ()
  (setq oldlayer (getvar "clayer"))
  (setq oldsnap (getvar "osmode"))
  (setq oldpick (getvar "pickbox"))
  (setq temperr *error*)
  (setq *error* trap)
  (princ)
)					;defun
;;;*===========================================================
(defun trap (errmsg)
  (command nil nil nil)
  (if (not (member errmsg '("console break" "Function Cancelled"))
      )
    (princ (strcat "\nError: " errmsg))
  )					;                 
  (setvar "clayer" oldlayer)
  (setvar "blipmode" 1)
  (setvar "menuecho" 0)
  (setvar "highlight" 1)
  (setvar "osmode" oldsnap)
  (setvar "pickbox" oldpick)
  (princ "\nError Resetting Enviroment ")
  (terpri)
  (setq *error* temperr)
  (princ)
)					;defun
;;;*===========================================================
(defun reset ()
  (setq *error* temperr)
  (setvar "clayer" oldlayer)
  (setvar "blipmode" 1)
  (setvar "menuecho" 0)
  (setvar "highlight" 1)
  (setvar "osmode" oldsnap)
  (setvar "pickbox" oldpick)
  (princ)
)					;defun
;;;*======================================================
;*dtr converts degrees to radians
(defun dtr (a)
 (* pi (/ a 180))
);defun
;*-----------------------------------------------------------------------------
;*rtd converts radians to degrees
(defun rtd (a)
 (/ (* a 180) pi)
);defun
;*-----------------------------------------------------------------------------
;;;* MARK marks the database for use with CATCH.
;;;*Written by Kenny Ramage Feb. '95
;;*----------------------------------------------------------------------
(defun MARK ( / val)
  (setq val (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (if (setq #mark (entlast))
    nil
    (progn
      (entmake '( (0 . "POINT") (10 0.0 0.0 0.0)))
      (setq #mark (entlast))
      (entdel #mark)
  ) )
  (setvar "cmdecho" val)
  (princ)
)
;*
;;;*-------------------------------------------------------------------
;* CATCH starts at MARK and retrieves to the end of the database.
(defun CATCH ( / ss)
  (if #mark
    (progn
      (setq ss (ssadd))
      (while (setq #mark (entnext #mark))
        (ssadd #mark ss)
      );while 
      ss
    );progn then
    (prompt "\n#MARK not set. Run MARK before CATCH.\n")    ;else
  );if
);defun
(princ)     
;* end of CATCH.LSP



