;;;--------------------------------------------------------------------;;;
;;;               .               ;;;
;;;                     Proc.lsp Version 1.1                           ;;;
;;;                  AutoCAD R14 for Windows                        ;;;
;;;                           2.02.99                                  ;;;
;;;                   :                          ;;;
;;;                           ;;;
;;;         "-  "           ;;;
;;;                 .     .59-16-23                     ;;;
;;;             E-Mail:  tb5@ugm.zsmk.nvkz.kuzbass.net                 ;;;
;;;--------------------------------------------------------------------;;;


;;
;;         .  
;;          Utilites
;;

;=============================================================
;;;  

;         
(defun UnBlock (pt ss / blkDat bn count Obj Objd Onjn blkName insDat insName)
    ; pt -   
    ; ss -  ,      
    ;            SSGET  SSADD
    
    (setq blkDat (list (cons 0 "BLOCK") (cons 2 "*Unnn") (cons 10 pt) (cons 70 1)) )
    (setq bn (entmake blkDat))
    
    (setq count (- (sslength ss) 1))
    (while (>= count 0)
        (setq Obj (ssname ss count))
        (setq Objd (entget Obj))
        (entdel Obj)
        (setq Onjn (entmake Objd))
        (setq count (- count 1))
    )
    (setq blkName (entmake '((0 . "ENDBLK")) ))
    (setq insDat (list (cons 0 "INSERT") (cons 2 blkName) (cons 10 pt) (cons 70 1)) )
    (setq insName (entmake insDat))
)

(defun $SaveLProp ()
;  
	(setq oldColor (getvar "CECOLOR"))	;  
	(setq oldLType (getvar "CELTYPE"))	;   
	;(setq oldWeight (getvar "CELWEIGHT"))	;  
)

(defun $RetLProp ()
;   
	(setvar "CECOLOR" oldColor)
	(setvar "CELTYPE" oldLType)
	;(setvar "CELWEIGHT" oldWeight)
)

(defun $setLTypeDim ()
	(setq TxtCOL (getvar "DIMCLRD"))	    ; , - 
										    ;  

	(setq TxtH (* (getvar "DIMTXT") Scale))	;  
											;  

	(setq ArWD (getvar "DIMLWD"))	        ;  , - 
									        ;  
	
	(setvar "CECOLOR" (rtos TxtCOL 2 0))
	(setvar "CELTYPE" "CONTINUOUS")
	;(setvar "CELWEIGHT" ArWD)
)

;;;   
;=============================================================


;;;  
;=============================================================
;    . 
(defun C:Proc ( / scale pt pAng Ang tAng tpt ss th Just K)
	(setq Scale (getvar "dimscale"))	;  
										;    
	(if (= (getvar "TILEMODE") 0)   ;   
		(setq scale 1)
	)
    (initget 1)
    (setq pt (getpoint "\n   : "))
    (initget 1)
    (setq Ang (getangle pt "\n : "))
    (initget 1)
    (setq pAng (getangle pt "\n,     : "))
    (cond
        ((and (>= (Round Ang 2) 0) (<= (Round Ang 2) (dtr 90)))
            (if (and (<= pAng (+ (dtr 180) Ang)) (>= pAng Ang))
                (progn
                    (setq tpt (polar pt Ang (* 2 scale)))
                    (setq tpt (polar tpt (+ Ang (dtr 90)) (* 0.5 scale)))
                    (setq K 1)
                    (setq tAng Ang)
                )
                (progn
                    (setq tpt (polar pt Ang (* 2 scale)))
                    (setq tpt (polar tpt (- Ang (dtr 90)) (* 4.5 scale)))
                    (setq K (- 1))
                    (setq tAng Ang)
                )
            )
        )
        ((and (> (Round Ang 2) (dtr 90)) (<= (Round Ang 2) (dtr 180)))
            (if (and (< pAng (+ (dtr 180) Ang)) (> pAng Ang))
                (progn
                    (setq tpt (polar pt (+ (dtr 180) Ang) (* 2 scale)))
                    (setq tpt (polar tpt (+ Ang (dtr 90)) (* 4.5 scale)))
                    (setq K 1)
                    (setq tAng (- Ang (dtr 180)))
                )
                (progn
                    (setq tpt (polar pt (+ (dtr 180) Ang) (* 2 scale)))
                    (setq tpt (polar tpt (- Ang (dtr 90)) (* 0.5 scale)))
                    (setq K (- 1))
                    (setq tAng (- Ang (dtr 180)))
                )
            )
        )
        ((and (> (Round Ang 2) (dtr 180)) (<= (Round Ang 2) (dtr 270)))
            (if (and (< pAng Ang) (> pAng (- Ang (dtr 180))))
                (progn
                    (setq tpt (polar pt (- Ang (dtr 180)) (* 2 scale)))
                    (setq tpt (polar tpt (- Ang (dtr 90)) (* 0.5 scale)))
                    (setq K (- 1))
                    (setq tAng (- Ang (dtr 180)))
                )
                (progn
                    (setq tpt (polar pt (- Ang (dtr 180)) (* 2 scale)))
                    (setq tpt (polar tpt (+ Ang (dtr 90)) (* 4.5 scale)))
                    (setq K 1)
                    (setq tAng (- Ang (dtr 180)))
                )
            )
        )
        ((and (> (Round Ang 2) (dtr 270)) (< (Round Ang 2) (dtr 360)))
            (if (and (< pAng Ang) (> pAng (- Ang (dtr 180))))
                (progn
                    (setq tpt (polar pt Ang (* 2 scale)))
                    (setq tpt (polar tpt (- Ang (dtr 90)) (* 4.5 scale)))
                    (setq K (- 1))
                    (setq tAng Ang)
                )
                (progn
                    (setq tpt (polar pt Ang (* 2 scale)))
                    (setq tpt (polar tpt (+ Ang (dtr 90)) (* 0.5 scale)))
                    (setq K 1)
                    (setq tAng Ang)
                )
            )
        )
    )
    
    ($SaveLProp)
    ($setLTypeDim)

    
    (setq ss (ssadd))   
    (osnap_off)
    (command "_pline" 
        pt
        (polar pt (+ Ang (* K (dtr 60))) (* 4 scale))
        (polar pt (+ Ang (* K (dtr 120))) (* 4 scale))
        "_c"
    )
    (ssadd (entlast) ss)
    (setq CurTxtStyle (getvar "TEXTSTYLE"))
	(setq th (cdr (assoc 40 (tblsearch "style" CurTxtStyle))))
    (if (= th 0.0)
		(command "_text" tpt (* 4 scale) (rtd tAng) "3")
		(command "_text" tpt (rtd tAng) "3")
	)
	(ssadd (entlast) ss)
    (UnBlock pt SS)
    (osnap_on)
    ($RetLProp)

    
    
)

;    . 
;(defun $Proc ( pt Ang)
;
;)

;=====================================
(princ "\n     Proc.lsp  ")
(princ "\n***                   ACAD TOOLS.  UTILITES                   ***")
(princ "\n***  , E-Mail: tb5@ugm.zsmk.nvkz.kuzbass.net ***")
