;;;---------------------------------------------------------------------------
;;;   Description : On-line Calculator. 
;;;                 You can use this while drafting in Autocad.
;;;
;;;   Prepared by : Sanjay Gandhe.
;;;   Date        : 10/01/1997.
;;;   
;;;                 Thermax limited.
;;;                 Enviro division.
;;;                 Pune.
;;;                 India.
;;;---------------------------------------------------------------------------
;;;  Last revision : 17/03/1997. By SDG.
;;;---------------------------------------------------------------------------
(defun tan (tang)(/ (sin (dtr tang)) (cos (dtr tang))))
;;;---------------------------------------------------------------------------
(defun dtr (deg)(/ (* deg pi) 180.0))
;;;---------------------------------------------------------------------------
(defun rtd (a)(* (/ 180 pi) a))
;;;---------------------------------------------------------------------------
(defun convert ()
    (push "+/-")
    (setq val (atof (get_tile "display")))
    (if (< val 0.0)
        (set_tile "display" (rtos (abs val)))
	(set_tile "display" (rtos (- 0.0 val)))
    )
    (setq old_val (get_tile "display"))
    (setq p_val (get_tile "display"))
)
;;;---------------------------------------------------------------------------
(defun c_time ()
    (setq dt (getvar "date"));real date 
    ;1 day =  60 seconds x 60 minuts x 24 hours
    (setq seconds (* 86400.0 (- dt (fix dt))))
    (setq minuts (/ seconds 60.0))
    (setq hours (/ seconds 3600.0))
    (if (> hours 12.0) (setq hours (- hours 12.0)))
    (setq minuts (* 60.0 (- hours (fix hours))))  
    (setq seconds (* 60.0 (- minuts (fix minuts))))
    (setq miliseconds (* 60.0 (- seconds (fix seconds))))
    (setq grt (strcat  
                 (rtos (fix hours) 2 0)":"
	         (rtos (fix minuts) 2 0)":"
	         (rtos (fix seconds) 2 0)":"
	         (rtos (fix miliseconds) 2 0)
	      )    
    )
)
;;;---------------------------------------------------------------------------
(defun cu_time ()
	  (c_time)
          (set_tile "time" (strcat " Time : " grt))
	  (set_tile "title" (strcat " Time : " grt))
)
;;;---------------------------------------------------------------------------
(defun image ()(start_image"t") (slide_image 0 0 1 1 "t")(end_image) (cu_time))
;;;---------------------------------------------------------------------------
(defun set_s_c_t (s_c_t) 
    (set_tile "display" 
       (rtos (cond ((= s_c_t 'sin) (progn (push "Sin")(sin (dtr (atof (get_tile "display"))))))
             ((= s_c_t 'cos) (progn (push "Cos")(cos (dtr (atof (get_tile "display"))))))
	     ((= s_c_t 'tan) (progn (push "Tan")(tan (atof (get_tile "display")))))
	     ((= s_c_t 'sqrt) (progn (push "Sqrt")(sqrt (atof (get_tile "display")))))
             )
       2 16
       )
    )
    (setq old_val result)
    (setq p_val nil)
    (cu_time)
)
;;;---------------------------------------------------------------------------
(defun set_pi () 
      (push "Pi")
      (setq p_val (rtos pi 2 12))
      (set_tile "display" (rtos pi 2 12))
      (cu_time)
)
;;;---------------------------------------------------------------------------
(defun mem_in () (push "Min")(set_tile "MM" (setq min_val (get_tile "display"))) (cu_time))
;;;---------------------------------------------------------------------------
(defun clear () (push "C")(set_tile "display" "0.0")(setq p_val nil)(func "") (cu_time))
;;;---------------------------------------------------------------------------
(defun all_clear () (push "AC")(set_tile "display" "0.0")(setq p_val nil)(func "") (set_tile "MM" "") (cu_time))
;;;---------------------------------------------------------------------------
(defun func (fu) (push fu) (set_tile "Func" (strcat fu " ")) (cu_time))
;;;---------------------------------------------------------------------------
(defun add_mem () 
         (push "M+")
         (set_tile "MM" 
	   (rtos 
	    (+ 
	     (atof (get_tile "MM")) 
	     (atof (get_tile "display"))
	    ) 
	    2 16
	    )
	  )
	  (cu_time)
)
;;;---------------------------------------------------------------------------
(defun delay (dt)(setq dtime 1)(while (<= dtime dt)(setq dtime (1+ dtime))))
;;;---------------------------------------------------------------------------
(defun set_mr () 
    (push "MR")
    (set_tile "display" (get_tile "MM"))
    (setq p_val (get_tile "display"))
    (cu_time)
)
;;;---------------------------------------------------------------------------
(defun push (what)
          (mode_tile what 1)
          (delay 500)
          (mode_tile what 0)
)
;;;---------------------------------------------------------------------------
(defun do_do (do)
     (push (itoa do))
     (if (= do 21) (setq doo '+))
     (if (= do 22) (setq doo '-))
     (if (= do 23) (setq doo '*))
     (if (= do 24) (setq doo '/))
     (mode_tile "." 0)
     (if (= do 11) (mode_tile "." 1))
     (if (and (not p_val) (= do 11))
         (progn
	  (setq p_val "0")
	  (set_tile "display" p_val)
	 )
     )
     (if (< do 21)
         (progn
	  (set_tile "display" 
	     (if p_val 
	       (progn
	         (if (= do 11) 
                     (setq p_val (strcat (get_tile "display") "."))
	             (setq p_val (strcat p_val (rtos do 2 0)))
		 )
	       )
	         (setq p_val (rtos do 2 0))
	     )
	  )
	 )
         (progn
	 (if (/= (get_tile "display") "")
	     (setq old_val (get_tile "display"))
	     (setq old_val p_val)
	  )
	  (setq p_val nil)
	 )
    )
    (cu_time)
;;;-------> My addiion <---------     
     (mode_tile "MM" 0)
     (mode_tile "Func" 0)
     (mode_tile "display" 0)
)
;;;---------------------------------------------------------------------------
(defun cal ()
          (push "=")
          (if (not p_val) (setq p_val old_val))
	  (setq result
	       (apply doo 
	          (list 
		   (if (= (type old_val) 'STR) (atof old_val) old_val)
		   (if (= (type p_val) 'STR) (atof p_val) p_val)
		  )
	       )
	  )
   	  (set_tile "display" (rtos result 2 12))
	  (setq old_val result)
	  (setq p_val nil)
	  (set_tile "Func" "=")
	  (cu_time)
)
;;;---------------------------------------------------------------------------
(defun dcl (dialog_name dcl_file)
      (new_dialog (strcase dialog_name) (setq dcl_id (load_dialog (strcase dcl_file))))
)
;------------------------------------------------------------------------------
(defun c:dcl_calc ()
     (setq ai_support nil *ERROR* nil old_val nil do nil doo nil)
     (dcl "DCL_CALC" "DCL_CALC")
     (mode_tile "MM" 1)
     (mode_tile "Func" 1)
     (mode_tile "display" 1)
     (setq v1 nil p_val nil)
     (set_tile "display" "            0.0")
     (set_tile "MM" "0.0")
     
     (action_tile "sdg" "(image)")
     ;;;Functions
     (action_tile "M+" "(add_mem)")
     (action_tile "Min" "(mem_in)")
     (action_tile "MR" "(set_mr)")     
     (action_tile "C" "(clear)")
     (action_tile "AC" "(all_clear)")
     
     (action_tile "Sin" "(set_s_c_t 'sin)")
     (action_tile "Cos" "(set_s_c_t 'cos)")
     (action_tile "Tan" "(set_s_c_t 'tan)")
     (action_tile "+/-" "(convert)")
     (action_tile "Sqrt" "(set_s_c_t 'sqrt)")
     
     ;;; Digits
     (action_tile "1" "(do_do 1)")
     (action_tile "2" "(do_do 2)")
     (action_tile "3" "(do_do 3)")
     (action_tile "4" "(do_do 4)")
     (action_tile "5" "(do_do 5)")
     (action_tile "6" "(do_do 6)")
     (action_tile "7" "(do_do 7)")
     (action_tile "8" "(do_do 8)")
     (action_tile "9" "(do_do 9)")
     (action_tile "0" "(do_do 0)")
     (action_tile "." "(do_do 11)")
     
     ;;; Functions
     (action_tile "+" "(do_do 21)(func (chr 43))")
     (action_tile "-" "(do_do 22)(func (chr 45))")
     (action_tile "X" "(do_do 23)(func (chr 88))")
     (action_tile "/" "(do_do 24)(func (chr 47))")
     (action_tile "Pi" "(set_pi)")
     (action_tile "=" "(cal)")
     ;(action_tile "accept"  "(cal)")
     (action_tile "accept"  "(done_dialog 1)")
     (start_dialog)

)
;;;---------------------------------------------------------------------------

