;;------------> DCLN.lsp <-------------------------------------------
;;  Adding PG for AutoCAD r14 12/08/97
;; 06/07/99  AutoCAD r15 (2000)
;;      
;;              
;;  
;;
;;   Copyright  \"SingleSoft PG\" "
;;                       mailto:gepos@mail.ru 
;;
;;------------------------------------------------------------------------
;;                05-06-1995  
;;__________________________________________________________

;
;----------------------------------------------------------
;ERROR FUNCTION
;__________________________________________________________
;error function
(defun *error* (msg)
(if (= msg "Function Abort")
(princ)
(princ msg)
)
(princ)
)
;__________________________________________________________
;**********************************************************
;rlin surf circ cild prof parl perp angl soax simm pozt crax
;                  bien  bies  shli  shfa
;      
;__________SOAX____________________________________________
(defun soax( pm / )  (command "TEXT" "m" pm 5 0 "" )
)
(defun simm( pm / )  (command "TEXT" "m" pm 5 0 "" )
)
(defun pozt( pm / )  (command "TEXT" "m" pm 5 0 "" )
)
(defun bien( pm / )  (command "TEXT" "m" pm 5 0 "" )
)
(defun bies( pm / )  (command "TEXT" "m" pm 5 0 "" )
)
(defun perp( pm / )  (command "TEXT" "m" pm 5 0 "" )
)
(defun parl( pm / )  (command "TEXT" "m" pm 5 0 "" )
)
(defun angl( pm / )  (command "TEXT" "m" pm 5 0 "" )
)
(defun crax( pm / )  (command "TEXT" "m" pm 5 0 "x" )
)
(defun shli( pm / )  (command "TEXT" "m" pm 5 0 "" )
)
(defun shfa( pm / )  (command "TEXT" "m" pm 5 0 "" )
)
(defun rlin( pm / )  (command "TEXT" "m" pm 5 0 "" )
)
(defun surf( pm / )  (command "TEXT" "m" pm 5 0 "" )
)
(defun circ( pm / )  (command "TEXT" "m" pm 5 0 "o" )
)
(defun cild( pm / )  (command "TEXT" "m" pm 5 0 "" )
)
(defun prof( pm / )  (command "TEXT" "m" pm 5 0 "=" )
)

;;    
;; END FUNCTION DECLINE TYPE
;;
(defun treg( / ps1 ps2 ps3 )
 (setq ps1 (list (+ (car p1) (nth 1 tzn)) (+ (cadr p1) (nth 2 tzn)))
       ps2 (list (- (car p1) (nth 1 tzn)) (- (cadr p1) (nth 2 tzn)))
       ps3 (list (+ (car p1) (nth 3 tzn)) (+ (cadr p1) (nth 4 tzn)))
  )
 (command "SOLID" ps1 ps2 ps3 ps3 "")
)
;__________________________________________________________
(defun strel()
 (setq ps1 (list (+ (car p1) (nth 9 tzn))  (+ (cadr p1) (nth 10 tzn)))
       ps2 (list (+ (car p1) (nth 11 tzn)) (+ (cadr p1) (nth 12 tzn)))
   )
 (command "SOLID" p1 ps1 ps2 ps2 "")
)
;__________________________________________________________
(defun box( / ps1 ps2 ps3 ps4 let ptx)
 (setq ps1 (list (+ (car p2) (nth 5 tzn)) (+ (cadr p2) (nth 6 tzn)))
       ps2 (list (- (car p2) (nth 5 tzn)) (- (cadr p2) (nth 6 tzn)))
       ps3 (list (+ (car ps1) (nth 7 tzn)) (+ (cadr ps1) (nth 8 tzn)))
       ps4 (list (+ (car ps2) (nth 7 tzn)) (+ (cadr ps2) (nth 8 tzn)))
       let (strcase(getstring "\n  : "))
       ptx (list (+ (min (car ps2)  (car ps4))  3)
                 (+ (min (cadr ps2) (cadr ps4)) 2.5))
   )
 (command "LINE" ps1 ps3 ps4 ps2 "c")
 (command "TEXT" ptx 5 0 let)
)
;__________________________________________________________
(defun ramka( x y / ps3 ps4 ps5 ps6 )
   (setq ps3 (list (+ x 0) (- y 5))
         ps4 (list x (+ (cadr ps3) 10))
         ps5 (list (+ x dltx) (cadr ps4))
         ps6 (list (car ps5) (- (cadr ps5) 10))
       )
 (cond
      ( (= (nth 0 tzn) 1)  (setq p4 ps3) )
      ( (= (nth 0 tzn) 2)  (setq p4 ps6) )
      ( (= (nth 0 tzn) 3)  (setq p4 ps6) )
      ( (= (nth 0 tzn) 4)  (setq p4 ps5) )
  )
   (command "LINE" ps3 ps4 ps5 ps6 "c")
   (setq ps3 (list (+ x 10) (cadr ps3))
         ps4 (list (car ps3) (+ (cadr ps3) 10))
   )
   (command "LINE" ps3 ps4 "")
)
;__________________________________________________________
(defun mfun(p0 / )
 (command "CIRCLE" p0 4)
 (setq p0 (list (-(car p0) 0.5) (cadr p0)))
 (command "TEXT" "m" p0 5 0 "M")
)
;__________________________________________________________
(defun remcen( ptx pty / psr1 )
 (setq psr1 (list (+ ptx 5) pty) )
 (tipf psr1) ; icon 
)


;**********************************************************
;_____MAIN FUNCTION________________________________________
;__________________________________________________________
;**********************************************************
(defun dcln( tipf / pt po1 po2 dx dy cmd1 dtxt dmt dbas mbas )

 (setq  p1 (getpoint "\n  : ")
        p2 (getpoint "\n : ")
        dx (- (car p2) (car p1))
        dy (- (cadr p2) (cadr p1))
      cmd1 (getvar "CMDECHO")
     )
 (setvar "CMDECHO" 0)
 (setvar "BLIPMODE" 0)

;-------    -------------------
;      P2
 (cond ((and (> (abs dx) (abs dy)) (>= dx 0))
                   (setq tzn (list 1 0 2 3.6 0 0 5 10 0 5 1.5 5 -1.5)
                         p2 (list (car p2) (cadr p1) )
                         p3 p2
          )           )
       ((and (< (abs dx) (abs dy))  (>= dy 0))
                   (setq tzn (list 2 2 0 0 3.6 5 0 0 10 -1.5 5 1.5 5)
                         p3 p2
                         p2 (list (car p1) (cadr p2) )
         )           )
       ((and (> (abs dx) (abs dy)) (< dx 0))
                   (setq tzn (list 3 0 2 -3.6 0 0 5 -10 0 -5 -1.5 -5 1.5)
                         p2 (list (car p2) (cadr p1) )
                         p3 p2
         )           )
       ((and (< (abs dx) (abs dy)) (< dy 0))
                   (setq tzn (list 4 2 0 0 -3.6 5 0 0 -10 1.5 -5 -1.5 -5)
                         p3 p2
                         p2  (list (car p1) (cadr p2))
         )           )
 )  ; close cond
;-------    cond N2  BASE-----------------
 (cond ( (= tipf base)     ;   Y
         (treg)
         (command "LINE" p1 p2 "")
         (box)
       ) ; end  1 
;-------    cond N2  DECLINE---------------
   ((/= tipf base) ;2 
        (strel)
        (setq dtxt (getstring T"\n  : ")
              dmt  (getstring "\n ? (Y,N) <N>: ")
              dbas (strcase
                (getstring "\n  <A,B.or ENTER   >: "))
              mbas (getstring "\n  ? (Y,N) <N>: ")
              dltx (+ (* (strlen dtxt) 4) 15)
         )
    ;----------
        (if (/= dbas "")                 (setq dltx (+ dltx 10)))
        (if (or(= dmt "Y")(= dmt "y"))   (setq dltx (+ dltx 8))   )
        (if (or(= mbas "Y")(= mbas "y")) (setq dltx (+ dltx 12))   )

    ;-----------   -
        (if(or (= (nth 0 tzn) 2) (= (nth 0 tzn) 4) )
          (if(> (car p3) (car p2))
                  (progn (setq p3 p2)
                         (command "LINE"  p1 p2 (command))
                     )
                 (progn (setq p3 (list (- (car p2) dltx) (cadr p2)))
                          (command "LINE" p1 p2 "")
        )   )        )
        (if(= (nth 0 tzn) 3) (progn
                         (setq p3 (list (- (car p2) dltx) (cadr p2)))
                         (command "LINE" p1 p2 "")
        )                )
        (if(= (nth 0 tzn) 1) (progn
                         (setq p3 p2)
                         (command "LINE" p1 p2 "")
        )                )

    ;-----------

      (remcen (car p3) (cadr p3))    ;  
      (ramka (car p3) (cadr p3))   ;  
      (setq pt (list (+ (car p3) 13) (- (cadr p3) 3)))
      (command "TEXT"  pt  5 0 dtxt)
    ;-----------------------
      (if (or (= dmt "Y") (= dmt "y"))
          (progn (setq pt (list (+ (car pt) (* (strlen dtxt) 4) 7)
                                (cadr p3)))
                 (mfun pt)
      )   )
     ;-----------------------
      (if (or (= mbas "Y") (= mbas "y"))
          (progn (setq pt (list (-(+ (car p3) dltx) 5) (cadr p3)))
                 (mfun pt)
                 ;-----
                 (if (/= dbas "")
                     (progn (setq pt (list (-(car pt) 8) (cadr pt)))
                            (command "TEXT" "m" pt 5 0 dbas)
                            (setq po1 (list (-(car pt) 3) (+(cadr pt) 5))
                                  po2 (list (car po1) (-(cadr po1) 10))
                            )
                            (command "LINE" po1 po2 "")
                     )
                     (progn (setq po1 (list (-(car pt) 5) (+(cadr pt) 5))
                                  po2 (list (car po1) (-(cadr po1) 10))
                            )
                            (command "LINE" po1 po2 "")
                     )
                 )
                 ;-----
          )   ;close progn --------
          (if (/= dbas "")
               (progn (setq pt (list (-(+ (car p3) dltx) 5) (cadr p3)))
                      (command "TEXT" "m" pt 5 0 dbas)
                      (setq po1 (list (-(car pt) 4) (+(cadr pt) 5))
                            po2 (list (car po1) (-(cadr po1) 10))
                      )
                      (command "LINE" po1 po2 "" )
                )
          ) ;close if(/=dbas "")
      ) ;  close if(/=mbas "")
     ;--------------------------------------
     (if (= dbas "")
         (progn  ;--         
             (initget 1)
             (setq p1 (getpoint "\n  : "))
             ;---------------
             (if (or (=(nth 0 tzn) 2) (=(nth 0 tzn) 4))
                (progn
                 (if (and (> (car p1) (car p3))
                          (< (car p1) (car p4)) )
                    (setq po2 (list (car p1) (-(cadr p4) (nth 8 tzn)))
                          po1 (list (car p4) (cadr po2)) )
                    (setq po1 (list (car p1) (cadr p4))
                          po2 po1 )
                 )
                 (command "LINE" p4 po1 po2 p1 "")
                )
                (progn
                 (setq po1 (list (car p4) (cadr p1)))
                 (command "LINE" p4 po1 p1 "")
                )
             )
             ;----------------
             (treg)
     )   )
      ;-------------------------
    )  ; end 2 
 ) ;close cond 2

(setvar "CMDECHO" cmd1)
(setvar "BLIPMODE" 1)
)

