;;--------> POSITION. LSP <------------------------------------------
;;
;;        
;;
;;;------------------------------------------------------------------------
;;  Adding PG for AutoCAD r14 12/08/97
;; 20/08/99  AutoCAD r15 (2000)
;; 
;;
;;
;;   Copyright  \"SingleSoft PG\" "
;;                       mailto:gepos@mail.ru 
;;
;;------------------------------------------------------------------------
;;------------------------------------------------------------------------
;error function
(defun *error* (msg)
(setq msg "Function Abort by user")
(princ)
(princ msg)
(princ)
)
;
;------------------> SIKOKA (zn) <-----------------------------------
(defun sikoka( z / pt num smech)
 (setq num (getstring "\n :  "))
 (cond ((= (strlen num) 1) (setq smech 6.0))
       ((= (strlen num) 2) (setq smech 3.0))
       ((>=(strlen num) 3) (setq smech 0.5))
 )
 (setq pt (list (- (car z) smech) (+ (cadr z) 1.5))
 )
 (command "TEXT" "r" pt 7 0 num)
)
;------------------> POLKA (p2 p3) <---------------------------------
(defun polka( px2 px3 / pt1 pt2)
 (setq pt1 (list (car px2) (- (cadr px2) 12))
       pt2 (list (car px3) (- (cadr px3) 12))
     )
 (command "LINE" px2 pt1 pt2 "")
 (if (> (car pt1) (car pt2)) (sikoka pt1) (sikoka pt2))
)
;------------------> POLKA2 (p2 p3) <--------------------------------
(defun polka2 ( x2 x3 / pt pt1 pt2)
 (setq pt  (list (car x2) (- (cadr x2) 12))
       pt1 (list (car x2) (- (cadr x2) 24))
       pt2 (list (car x3) (- (cadr x3) 24))
     )
 (command "LINE" pt pt1 pt2 "")
 (if (> (car pt1) (car pt2)) (sikoka pt1) (sikoka pt2))
)
;------------------> POLKA3 (p2 p3) <--------------------------------
(defun polka3 ( x2 x3 / pt pt1 pt2)
 (setq pt  (list (car x2) (- (cadr x2) 24))
       pt1 (list (car x2) (- (cadr x2) 36))
       pt2 (list (car x3) (- (cadr x3) 36))
     )
 (command "LINE" pt pt1 pt2 "")
 (if (> (car pt1) (car pt2)) (sikoka pt1) (sikoka pt2))
)
;--------------------------------------------------------------------
;-------------> MAIN POSITION <--------------------------------------
;
(defun c:position( / p1 p2 p3 typ zn dlin cmd1 blm osmd)
 
 (initget 3)
 (setq p1 (getpoint "\n  : ")
     dlin 17.0
     cmd1 (getvar "CMDECHO")
      blm (getvar "BLIPMODE")
     osmd (getvar "OSMODE")
 )
 (setvar "CMDECHO" 0)
 (setvar "BLIPMODE" 0)
 (setvar "OSMODE" 0)

 (while p1
  (setq p2 (getpoint p1 "\n   : ")
        p3 (getpoint "\n - : ")
    )
  (setq typ 5)
  (while (and (/= typ 1) (/= typ 2) (/= typ 3) (/= typ 4) )
    (setq typ (getint "\n-  (1/2/3/4) <1>: "))
    (if (= typ nil) (setq typ 1))
   )
  (if (> (car p3) (car p2))
      (setq p3 (list (+(car p2) dlin) (cadr p2))
            zn p3) ;
      (setq p3 (list (-(car p2) dlin) (cadr p2))
            zn p2)
   )
  (command "LINE" p1 p2 p3 "")
  (cond ((= typ 1)  (sikoka zn))
        ((= typ 2)  (sikoka zn)
                     (polka p2 p3)    )
        ((= typ 3)  ( sikoka zn )
                     ( polka p2 p3)  ( polka2 p2 p3)  )
        ((= typ 4)  ( sikoka zn )
                     ( polka p2 p3)  ( polka2 p2 p3) ( polka3 p2 p3)  )
   )
  
  (setq p1 (getpoint "\n  : "))   ;; If <ENTER> p1-> nill
 ) ;WHILE  -> p1 close

 (setvar "CMDECHO" cmd1)
 (setvar "BLIPMODE" blm)
 (setvar "OSMODE" osmd)
)

