;;------------------------------------------------------------------------
;;               RADFAS v.2
;;       
;;   04/10/99
;;    use RADFAS.dcl, bmp
;;   Copyright  \"SingleSoft PG\" "
;;                       mailto:gepos@mail.ru 
;;
;;------------------------------------------------------------------------
(defun f_rad ( rad / )
  (COMMAND "_FILLET" "r" rad "_fillet")
)
;;------------------------------------------------------------------------
(defun f_fas ( d1 d2 tip ug / pi ug)

 (setq pi 3.1415)
 (if (= d2 0) (setq d2 d1)
  )
 (if (not (= ug 0)) 
      (setq ug (/(*(atof ug) pi) 180.0))
  )
 (if (= tip 2) 
        (setq d2 (/(*(sin ug)(atof d1))(cos ug)) )
  )
(COMMAND "_CHAMFER" "d" d1 d2 "_chamfer")
)
;;------------------------------------------------------------------------
(defun ab_prog (ab_progr /)
 
 (if (not (new_dialog "ab_text" DCL_ID)) (exit))
 
 (start_list "ab_progr")
 (mapcar 'add_list ab_progr)
 (end_list)

 (action_tile  "accept" "(done_dialog)")
 (start_dialog)
)
;;------------------------------------------------------------------------
;;------------------------------------------------------------------------
(defun c:radfas	(/ $value rf rf_sp rf_zn 
                          ff ff_zn DCL_ID tp a_sel
                          uf ug_sp ug_zn)

  (setq	rf_sp (list "0" "0.5" "1" "1.2" "1.5" "2.0" "2.5" "3.0" "3.5" "4" 
                    "4.5" "5" "5.5" "6" "7" "8" "9" "10" )
        ug_sp (list  "0" "5" "10" "15" "20" "30" "45" "60" "70" "75" "80")
        rf 0  ff 0  uf 0
        a_sel 0
        info_pr (list
		 " -      - " " "
		 "      "
                 "   .  "
		 "        "
		 " . "   "  "
                 "     1,    " 
                 "   ,    "
                 "    1   . "
                 ""
		 "   -  .  "
                 " 04  1999."
                 "          Copyright  \"SingleSoft PG\" "
                 "                             mailto:gepos@mail.ru "
                )
   )
   
  (setq DCL_ID (load_dialog "radfas.dcl"))

  (if (not (new_dialog "radfas" DCL_ID))
    (exit)
  )

  (start_list "rf_zn" 3) (mapcar 'add_list rf_sp) (end_list)
  (start_list "ff_zn" 3) (mapcar 'add_list rf_sp) (end_list)
  (start_list "ug_zn" 3) (mapcar 'add_list ug_sp) (end_list)

  (set_tile "on_f2" "0")   (set_tile "on_ug" "0")

  (mode_tile "ff_zn" 1)    (mode_tile "ug_zn" 1)

  (action_tile "on_f2" 
               "(progn (mode_tile \"ff_zn\" 0)(mode_tile \"ff_zn\" 2)
                   (mode_tile \"ug_zn\" 1)(setq a_sel 1))") 
  (action_tile "on_ug" 
               "(progn (mode_tile \"ug_zn\" 0)(mode_tile \"ug_zn\" 2)
                   (mode_tile \"ff_zn\" 1)(setq a_sel 2))") 
  (action_tile "rf_zn" "(setq rf (nth (atoi $value) rf_sp))")
  (action_tile "ff_zn" "(setq ff (nth (atoi $value) rf_sp))")
  (action_tile "ug_zn" "(setq uf (nth (atoi $value) ug_sp))")
  (action_tile "s_radius" "(progn(setq tp 1)(done_dialog 1))")
  (action_tile "s_fas"    "(progn(setq tp 2)(done_dialog 1))")
  (action_tile "info" "(ab_prog info_pr)")
  (action_tile "cancel" "(done_dialog 0)")
  (if (= 1 (start_dialog))
    (progn
        (if (= tp 1) (f_rad rf ) )
        (if (= tp 2) (f_fas rf ff a_sel uf) )
    )
  )
  ;; close IF &  Progn
  (unload_dialog DCL_ID)
)
;;
;;****************> END <********************************



